# delimit ;  
set more 1 ;  
log using C:\Pension\pension2.log, replace ; 
program drop _all;
use C:\Pension\pension1, replace;

gen respondent=real(CaseID);

* get HHIDPN into a useable format;
gen long temp=real(HHIDPN);
drop HHIDPN;
rename temp HHIDPN;
gen long temp=HHIDPN/1000;
gen long HHID=int(temp);
replace temp=HHID*1000;
gen PN=HHIDPN-temp;


* I think these are missing value codes (must be, > 10000000);
replace S1A50=0 if S1A50>10000000;
replace S1A55=0 if S1A55>10000000;
replace S1A60=0 if S1A60>10000000;
replace S1A65=0 if S1A65>10000000;
replace S11992=0 if S11992>10000000;
replace S1P92=0 if S1P92>10000000;

* generate variables for person-specific pension wealth;
gen penage50=S1A50;
gen penage55=S1A55;
gen penage60=S1A60;
gen penage65=S1A65;
gen penyear92=S11992;
gen oldpen92=S1P92;

* make unit of observation a person, not a plan;
sort respondent;
gen duplicate=0;
replace duplicate=1 if respondent==respondent[_n-1];
* code the Steinmeier dataset----------------------------;
* generate a measure of total pension wealth, Steinmeier dataset;
replace penage50=penage50+penage50[_n-1] if duplicate==1;
replace penage55=penage55+penage55[_n-1] if duplicate==1;
replace penage60=penage60+penage60[_n-1] if duplicate==1;
replace penage65=penage65+penage65[_n-1] if duplicate==1;
replace penyear92=penyear92+penyear92[_n-1] if duplicate==1;
replace oldpen92=oldpen92+oldpen92[_n-1] if duplicate==1;
gen currpen=S11992+S1P92;
gen Steinpen=penyear92+oldpen92;


sort respondent;
drop if respondent==respondent[_n+1];
sort respondent;


sort HHID PN;
sort respondent;
save  C:\Pension\pension2, replace;
summ;
*drop _all;
log close;

