# delimit ;  
set more 1 ;  
log using C:\Pension\pension3.log, replace ; 
program drop _all;
* this program merges in output from the pension calculator with pension1.do, written by Steinmeier;

***********code up last job data**************;
use C:\Pension\outlast, replace;
gen DBLast=0;
replace DBLast=1 if (CodeID>0 & CodeID<3001);
gen DCLast=0;
replace DCLast=1 if (CodeID>3000 & CodeID<5001);
gen BOTHLast=0;
replace BOTHLast=1 if (CodeID>5000 & CodeID<6000);
* code up pension wealth calculator variable for total pension wealth;
gen penvalLast=maxnrervd+pv_dc_;
gen CalcpenLast=penvalLast;
gen CalcDCLast=pv_dc_;
rename CashFlows1 CashFlowsLast1;
rename CashFlows10 CashFlowsLast10;
rename Wage WageLast;
gen TenureLast=QuitDate-real(HireDate);


*missings to 0s;
replace DBLast=0 if DBLast==.;
replace DCLast=0 if DCLast==.;
replace BOTHLast=0 if BOTHLast==.;
replace CalcpenLast=0 if CalcpenLast==.;
replace CalcDCLast=0 if CalcDCLast==.;
replace CashFlowsLast1=0 if CashFlowsLast1==.;
replace CashFlowsLast10=0 if CashFlowsLast10==.;

* make unit of observation a person, not a plan;
sort respondent;
gen duplicate=0;
replace duplicate=1 if respondent==respondent[_n-1];

replace DBLast=1 if duplicate==1 & DBLast[_n-1]==1;
replace DCLast=1 if duplicate==1 & DCLast[_n-1]==1;
replace BOTHLast=1 if duplicate==1 & BOTHLast[_n-1]==1;

replace CalcpenLast=CalcpenLast+CalcpenLast[_n-1] if duplicate==1 & CalcpenLast[_n-1]~=.;
replace CalcDCLast=CalcDCLast+CalcDCLast[_n-1] if duplicate==1 & CalcDCLast[_n-1]~=.;

replace CashFlowsLast1=CashFlowsLast1+CashFlowsLast1[_n-1] if duplicate==1 & CashFlowsLast1[_n-1]~=.;
replace CashFlowsLast10=CashFlowsLast10+CashFlowsLast10[_n-1] if duplicate==1 & CashFlowsLast10[_n-1]~=.;

sort respondent;
drop if respondent==respondent[_n+1];
sort respondent;


save C:\Pension\outlastX, replace;

***********code up previous job data**************;
use C:\Pension\outprev, replace;

gen DBPrev=0;
replace DBPrev=1 if (CodeID>0 & CodeID<3001);
gen DCPrev=0;
replace DCPrev=1 if (CodeID>3000 & CodeID<5001);
gen BOTHPrev=0;
replace BOTHPrev=1 if (CodeID>5000 & CodeID<6000);
* code up pension wealth calculator variable for total pension wealth;
gen penvalPrev=maxnrervd+pv_dc_;
gen CalcpenPrev=penvalPrev;
gen CalcDCPrev=pv_dc_;
rename CashFlows1 CashFlowsPrev1;
rename CashFlows10 CashFlowsPrev10;
rename Wage WagePrev;
gen TenurePrev=QuitDate-real(HireDate);

*missings to 0s;
replace DBPrev=0 if DBPrev==.;
replace DCPrev=0 if DCPrev==.;
replace BOTHPrev=0 if BOTHPrev==.;
replace CalcpenPrev=0 if CalcpenPrev==.;
replace CalcDCPrev=0 if CalcDCPrev==.;
replace CashFlowsPrev1=0 if CashFlowsPrev1==.;
replace CashFlowsPrev10=0 if CashFlowsPrev10==.;

* make unit of observation a person, not a plan;
sort respondent;
gen duplicate=0;
replace duplicate=1 if respondent==respondent[_n-1];

replace DBPrev=1 if duplicate==1 & DBPrev[_n-1]==1;
replace DCPrev=1 if duplicate==1 & DCPrev[_n-1]==1;
replace BOTHPrev=1 if duplicate==1 & BOTHPrev[_n-1]==1;

replace CalcpenPrev=CalcpenPrev+CalcpenPrev[_n-1] if duplicate==1 & CalcpenPrev[_n-1]~=.;
replace CalcDCPrev=CalcDCPrev+CalcDCPrev[_n-1] if duplicate==1 & CalcDCPrev[_n-1]~=.;

replace CashFlowsPrev1=CashFlowsPrev1+CashFlowsPrev1[_n-1] if duplicate==1 & CashFlowsPrev1[_n-1]~=.;
replace CashFlowsPrev10=CashFlowsPrev10+CashFlowsPrev10[_n-1] if duplicate==1 & CashFlowsPrev10[_n-1]~=.;

sort respondent;
drop if respondent==respondent[_n+1];
sort respondent;

save C:\Pension\outprevX, replace;

***********code up current job data**************;
use C:\Pension\outcurr, replace;
gen DBCurr=0;
replace DBCurr=1 if (CodeID>0 & CodeID<3001);
gen DCCurr=0;
replace DCCurr=1 if (CodeID>3000 & CodeID<5001);
gen BOTHCurr=0;
replace BOTHCurr=1 if (CodeID>5000 & CodeID<6000);
* code up pension wealth calculator variable for total pension wealth;
gen penvalCurr=maxnrervd+pv_dc_;
gen CalcpenCurr=penvalCurr;
gen CalcDCCurr=pv_dc_;
rename CashFlows1 CashFlowsCurr1;
rename CashFlows10 CashFlowsCurr10;
rename Wage WageCurr;
gen TenureCurr=QuitDate-real(HireDate);


*missings to 0s;
replace DBCurr=0 if DBCurr==.;
replace DCCurr=0 if DCCurr==.;
replace BOTHCurr=0 if BOTHCurr==.;
replace CalcpenCurr=0 if CalcpenCurr==.;
replace CalcDCCurr=0 if CalcDCCurr==.;
replace CashFlowsCurr1=0 if CashFlowsCurr1==.;
replace CashFlowsCurr10=0 if CashFlowsCurr10==.;

* make unit of observation a person, not a plan;
sort respondent;
gen duplicate=0;
replace duplicate=1 if respondent==respondent[_n-1];

replace DBCurr=1 if duplicate==1 & DBCurr[_n-1]==1;
replace DCCurr=1 if duplicate==1 & DCCurr[_n-1]==1;
replace BOTHCurr=1 if duplicate==1 & BOTHCurr[_n-1]==1;

replace CalcpenCurr=CalcpenCurr+CalcpenCurr[_n-1] if duplicate==1 & CalcpenCurr[_n-1]~=.;
replace CalcDCCurr=CalcDCCurr+CalcDCCurr[_n-1] if duplicate==1 & CalcDCCurr[_n-1]~=.;

replace CashFlowsCurr1=CashFlowsCurr1+CashFlowsCurr1[_n-1] if duplicate==1 & CashFlowsCurr1[_n-1]~=.;
replace CashFlowsCurr10=CashFlowsCurr10+CashFlowsCurr10[_n-1] if duplicate==1 & CashFlowsCurr10[_n-1]~=.;

sort respondent;
drop if respondent==respondent[_n+1];
sort respondent;


save C:\Pension\outcurrX, replace;


***********code up current job data, quit in different years**************;
local i = 93;
while `i' <= 110 {;
use C:\Pension\outcurr`i', replace;

gen DBCurr`i'=0;
replace DBCurr`i'=1 if (CodeID>0 & CodeID<3001);
gen DCCurr`i'=0;
replace DCCurr`i'=1 if (CodeID>3000 & CodeID<5001);
gen BOTHCurr`i'=0;
replace BOTHCurr`i'=1 if (CodeID>5000 & CodeID<6000);
* code up pension wealth calculator variable for total pension wealth;
gen penvalCurr`i'=maxnrervd+pv_dc_;
gen CalcpenCurr`i'=penvalCurr`i';
gen CalcDCCurr`i'=pv_dc_;
rename CashFlows1 CashFlowsCurr`i'1;
rename CashFlows10 CashFlowsCurr`i'10;
rename Wage WageCurr`i';
gen TenureCurr`i'=QuitDate-real(HireDate);

*missings to 0s;
replace DBCurr`i'=0 if DBCurr`i'==.;
replace DCCurr`i'=0 if DCCurr`i'==.;
replace BOTHCurr`i'=0 if BOTHCurr`i'==.;
replace CalcpenCurr`i'=0 if CalcpenCurr`i'==.;
replace CalcDCCurr`i'=0 if CalcDCCurr`i'==.;
replace CashFlowsCurr`i'1=0 if CashFlowsCurr`i'1==.;
replace CashFlowsCurr`i'10=0 if CashFlowsCurr`i'10==.;



* make unit of observation a person, not a plan;
sort respondent;
gen duplicate=0;
replace duplicate=1 if respondent==respondent[_n-1];

replace DBCurr`i'=1 if duplicate==1 & DBCurr`i'[_n-1]==1;
replace DCCurr`i'=1 if duplicate==1 & DCCurr`i'[_n-1]==1;
replace BOTHCurr`i'=1 if duplicate==1 & BOTHCurr`i'[_n-1]==1;

replace CalcpenCurr`i'=CalcpenCurr`i'+CalcpenCurr`i'[_n-1] if duplicate==1 & CalcpenCurr`i'[_n-1]~=.;
replace CalcDCCurr`i'=CalcDCCurr`i'+CalcDCCurr`i'[_n-1] if duplicate==1 & CalcDCCurr`i'[_n-1]~=.;

replace CashFlowsCurr`i'1=CashFlowsCurr`i'1+CashFlowsCurr`i'1[_n-1] if duplicate==1 & CashFlowsCurr`i'1[_n-1]~=.;
replace CashFlowsCurr`i'10=CashFlowsCurr`i'10+CashFlowsCurr`i'10[_n-1] if duplicate==1 & CashFlowsCurr`i'10[_n-1]~=.;

sort respondent;
drop if respondent==respondent[_n+1];
sort respondent;

save C:\Pension\outcurr`i'X, replace;
local i =  `i' + 1;
};


***********merge data********************;
use c:\Pension\outcurrx;

sort respondent;
merge respondent using C:\Pension\pension2;
tab _merge;
drop _merge;
sort respondent;

merge respondent using C:\Pension\outlastX;
tab _merge;
drop _merge;

sort respondent;
merge respondent using C:\Pension\outprevX;
tab _merge;
drop _merge;

******** merge in current job, future quit dates;

local i = 93;
while `i' <= 110 {;
sort respondent;
merge respondent using C:\Pension\outcurr`i'X;
tab _merge;
drop _merge;
local i = `i' + 1;
};


* get rid of useless stuff;
keep CashFlowsC* CashFlowsL* CashFlowsP* *Curr* *Last *Prev *pen respondent CodeID* pen* HH* PN old* S11992 S1P92 S1PT;
keep CashFlowsC* CashFlowsL* CashFlowsP* res* *pen*     S1PT S1P92 HHID* PN   *DB* *DC* *BOTH* Wage* Tenure*;


gen CalcpenPast=CalcpenLast;
replace CalcpenPast=0 if CalcpenPast==. & CalcpenPrev~=.;
replace CalcpenPast=CalcpenPast+CalcpenPrev if CalcpenPrev~=.;


sum Steinpen CalcpenCurr;
reg Steinpen CalcpenCurr;

sum penyear92 CalcpenCurr;
reg penyear92 CalcpenCurr;

sum oldpen92 CalcpenPast if oldpen92~=. & CalcpenPast~=.;;
reg oldpen92 CalcpenPast;

two sc penyear92 CalcpenCurr ;
two sc oldpen92 CalcpenPast;

*sum if respondent~=. & HHID==.;


* Use the pension calculator value, but use the Steinmeier value if the pension calculator value is missing;
*replace CalcpenCurr=Steinpen if CalcpenCurr==.;
keep HHID PN HHIDPN Calcpen* Steinpen CalcDC* *DB* DC* *BOTH* CashFlowsC* CashFlowsL* CashFlowsP* Wage* Tenure*;

sort HHIDPN;


save  C:\pension\pension3, replace;
summ;
*drop _all;
log close;

