# delimit ;
 set more 1 ;
log using C:\HRS\SSA3\STATA\penacc2.log, replace ;
drop _all;

use C:\HRS\SSA3\STATA\penacc1; 


gen learn=ln(earn);


replace earn=WageCurr;
gen paccrate=pacc/earn if earn>10000;

gen earnage=learn*age;
gen earnage2=learn*age2;
gen earnage3=learn*age3;
gen earnage62=learn*age62;
gen earnage65=learn*age65;




sort age;
*by age: sum paccrate;
*truncate the bottom, top .1% of the distribution;
drop if paccrate<-.75|(paccrate> 3.5   & paccrate~=.);
*by age: sum paccrate;

/*
sort age;
by age: sum paccrate pacc Calcpen* pencurr if instype==1;
by age: sum paccrate pacc Calcpen* pencurr if instype==2;
by age: sum paccrate pacc Calcpen* pencurr if instype==3;

reg pacc instied inseprhi ;
reg pacc instied inseprhi earn;
reg pacc instied inseprhi learn;
reg pacc instied inseprhi learn age age2 age62 age65;
reg pacc instied inseprhi age penDCcurrT penDBcurrT;
reg paccrate instied inseprhi age penDCcurrT penDBcurrT;
*/




*****************generate accrual rates, by insurance type ************;
/*
reg paccrate age1 age2  age60 age61 age62 age63 age64 age65 if instype==1; * no insurance;
predict paccnone;
reg paccrate age1 age2  age60 age61 age62 age63 age64 age65 if instype==2; * retiree insurance;
predict paccret;
reg paccrate age1 age2  age60 age61 age62 age63 age64 age65 if instype==3; * tied insurance;
predict pacctied;
*/

*tab pacc;
*exit;
/*drop if pacc<-100000|pacc>200000;
reg paccrate age1 age2  age61 age64 if instype==1; * no insurance;
predict paccnone;
reg paccrate age1 age2  age61 age64 if instype==2; * retiree insurance;
predict paccret;
reg paccrate age1 age2  age61 age64 if instype==3; * tied insurance;
predict pacctied;
*/
gen insnone=1-(inseprhi+instied);


reg paccrate 
age1 age2 age3 age4 age62 age65
instied inseprhi 
agetied ageeprhi 
age2tied age2eprhi 
age3tied age3eprhi 
eprhi62 eprhi65 tied62 tied65 
learn earnage earnage2 earnage3 earnage62 earnage65 if age<75;



egen mearn=mean(learn);
egen mearneprhi=mean(learn) if inseprhi==1;
egen mearntied=mean(learn) if instied==1;
egen mearnnone=mean(learn) if insnone==1;

gen ageshift=_b[_cons]+(_b[age1]*age1)+(_b[age2]*age2) +(_b[age3]*age3) +(_b[age4]*age4) + (_b[age62]*age62) + (_b[age65]*age65)   ;
gen tiedshift=_b[instied]+_b[agetied]*age +_b[age2tied]*age2 +_b[age3tied]*age3 + _b[tied62]*age62 + _b[tied65]*age65;
gen eprhishift=_b[inseprhi]+_b[ageeprhi]*age +_b[age2eprhi]*age2 +_b[age3eprhi]*age3 + _b[eprhi62]*age62 + _b[eprhi65]*age65 ;
gen earnshift=_b[learn]+_b[earnage]*age +_b[earnage2]*age2 +_b[earnage3]*age3 +_b[earnage62]*age62 +_b[earnage65]*age65;

egen stdearn=sd(learn);
sum stdearn;

* generate calculations, for different types of ins;
gen paccnone=ageshift+ earnshift*mearn;
gen pacctied=ageshift+ earnshift*mearn +tiedshift;
gen pacceprhi=ageshift+ earnshift*mearn +eprhishift;

gen paccearn=earnshift*stdearn;
sum earnshift stdearn paccearn;
 


sort age;
replace paccnone=paccnone[_n-1] if age==age[_n-1] & paccnone==.;
replace pacctied=pacctied[_n-1] if age==age[_n-1] & pacctied==.;
replace pacceprhi=pacceprhi[_n-1] if age==age[_n-1] & pacceprhi==.;

sort age;
drop if age==age[_n+1];
drop if age<52|age>70;

two conn pacceprhi pacctied paccnone paccearn age, legend(lab(1 "retiree") lab(2 "tied") lab(3 "none") lab(4 "one s.d. increase in earnings"))
msymbol(T S D O) lpattern(solid longdash shortdash longdash_dot) plotregion(ifcolor(blue*0.08)) 
ti("Pension Accrual Rates, by Age and Health Insurance Type", size(medsmall)) ytitle("Accrual Rate") saving(accrual, replace);;

sort age;
by age: sum pacceprhi pacctied paccnone paccearn age mearn ageshift earnshift tiedshift eprhishift;



graph use accrual.gph;
graph export C:\HRS\SSA3\STATA\accrual.eps, replace;

keep age ageshift tiedshift eprhishift earnshift;

outsheet using C:\HRS\SSA3\STATA\penprof,nonames replace;

 
log close ;
program drop _all ;
*drop _all ;

