# delimit ;
 set more 1 ;
log using C:\HRS\SSA3\STATA\penacc3.log, replace ;
drop _all;
program drop _all;
use C:\HRS\SSA3\STATA\penacc1; 

/*
Basic facts I would like to know

I would like to know everything below, both for the full sample and for those aged 51-55, (do it first not conditioning on lfpr, then conditioning on lfpr).

Prob(tied=1), prob(eprhi=1), prob(none=1)=1- (Prob(tied=1) + prob(eprhi=1))
For the current job: 
Prob(DB=1), prob(DC=1), prob(BOTH=1), prob(none=1)=1- (Prob(DB=1) + prob(DC=1) + prob(BOTH=1))
For the current job, get the conditional probabilities:
Prob(DB=1| HI), prob(DC=1| HI), prob(BOTH=1| HI), prob(none=1| HI)=1- (Prob(DB=1| HI) + prob(DC=1| HI) + prob(BOTH=1| HI)), 
where HI = {tied, eprhi, none}
*/
/* recode some variables */
rename instype insnone;
replace insnone=0 if insnone~=1;
gen penBOTHcurrT=0;
replace penBOTHcurrT=1 if penDBcurrT==1 & penDCcurrT==1;
replace penDBcurrT=0 if penBOTHcurrT==1;
replace penDCcurrT=0 if penBOTHcurrT==1;

gen agerange=0;
replace agerange=1 if age>50 & age<56;


program define summdat;
args arange lfpra;

qui gen subset = 0;
if `lfpra' == 1 & `arange' == 1 {;
qui replace subset = 1 if agerange==`arange' & lfpr == `lfpra';
};

if `lfpra' == 0 & `arange' == 1 {;
qui replace subset = 1 if agerange==`arange';
};

if `lfpra' == 1 & `arange' == 0 {;
qui replace subset = 1 if lfpr == `lfpra';
};

if `lfpra' == 0 & `arange' == 0 {;
qui replace subset = 1;
* working, age 51-55;
};

display "";display "";
display "Summary Statistics for lfpr=`lfpra' and agerange=`arange'--first unconditional insurance and pension probabilities";
sum ins* if subset == 1;
sum pen*currT if subset == 1;
sum lfpr agerange if subset ==1;
display "";
display "No Insurance for lfpr=`lfpra' and agerange=`arange'";
sum pen*currT if insnone==1 & subset == 1;
display "";
display "Retiree Insurance for lfpr=`lfpra' and agerange=`arange'";
sum pen*currT if inseprhi==1 & subset == 1;
display "";
display "Tied Insurance for lfpr=`lfpra' and agerange=`arange'";
sum pen*currT if instied==1 & subset == 1;
display "";display "";
qui drop subset;

end;

summdat 0 0;
summdat 1 0;
summdat 0 1;
summdat 1 1;

gen learn=ln(earn);
gen earnage=learn*age;
gen earnage2=learn*age2;
gen earnage3=learn*age3;
gen earnage62=learn*age62;
gen earnage65=learn*age65;
gen tiedearn=instied*learn;
gen eprhiearn=inseprhi*learn;
gen earn2=learn*learn;


reg pencurr instied inseprhi  learn if agerange==1 & lfpr==1;
logit pencurr instied inseprhi  learn      if agerange==1 & lfpr==1;
logit pencurr instied inseprhi tiedearn eprhiearn learn earn2 if agerange==1 & lfpr==1;


gen cons=_b[_cons]  ;
gen instiedp=_b[instied];
gen inseprhip=_b[inseprhi];
gen tiedearnp=_b[tiedearn];
gen eprhiearnp=_b[eprhiearn]; 
gen learnp=_b[learn];
gen earn2p=_b[earn2];

drop if HHID[_n+1]~=.;
keep cons instiedp inseprhip tiedearnp eprhiearnp learnp earn2p ;

outsheet using C:\HRS\SSA3\STATA\penprob,nonames replace;

                                                                                                                 

log close ;
program drop _all ;
drop _all ;

