# delimit ;
 set more 1 ;
drop _all;

capture log close;
set mem 500m;
log using C:\HRS\SSA3\STATA\restrict1.log, replace ;


use C:\HRS\SSA3\STATA\SSAEAR3;

/*
sort HHIDPN;
save C:\HRS\SSA3\STATA\SSAEAR3, replace;

use C:\HRS\SSA3\STATA\SSABEN3;
sort HHIDPN;
save C:\HRS\SSA3\STATA\SSABEN3, replace;

merge HHIDPN using C:\HRS\SSA3\STATA\SSAEAR3;
save C:\HRS\SSA3\STATA\EARBEN, replace;
*/


sort HHIDPN;
keep HHID* qc* earn* ;


program define genwork;
        version 3.1;
        local i=51;
	while `i'<92 {;

gen work`i' =  qcs`i';
replace work`i'=1 if qcs`i'>1 & qcs`i'<5;

local i=`i'+1};
end;

genwork;

/*
gen work85=qcs85;
gen work86=qcs86;
gen work87=qcs87;
gen work88=qcs88;
gen work89=qcs89;
gen work90=qcs90;
gen work91=qcs91; */
*replace work91=1 if qcs91>1 & qcs91<5;
 

reshape long qcs earn, i(HHIDPN) j(year);


* average wage index, from ;
* http://www.ssa.gov/OACT/COLA/AWI.html;
gen AW=.;
replace AW= 2799.16 if year==51;
replace AW= 2973.32 if year==52;
replace AW= 3139.44 if year==53;
replace AW= 3155.64 if year==54;
replace AW= 3301.44 if year==55;
replace AW= 3532.36 if year==56;
replace AW= 3641.72 if year==57;
replace AW= 3673.80 if year==58;
replace AW= 3855.80 if year==59;
replace AW= 4007.12 if year==60;
replace AW= 4086.76 if year==61;
replace AW= 4291.40 if year==62;
replace AW= 4396.64 if year==63;
replace AW= 4576.32 if year==64;
replace AW= 4658.72 if year==65;
replace AW= 4938.36 if year==66;
replace AW= 5213.44 if year==67;
replace AW= 5571.76 if year==68;
replace AW= 5893.76 if year==69;
replace AW= 6186.24 if year==70;
replace AW= 6497.08 if year==71;
replace AW= 7133.80 if year==72;
replace AW= 7580.16 if year==73;
replace AW= 8030.76 if year==74;
replace AW= 8630.92 if year==75;
replace AW= 9226.48 if year==76;
replace AW= 9779.44 if year==77;
replace AW= 10556.03 if year==78;
replace AW= 11479.46 if year==79;
replace AW= 12513.46 if year==80;
replace AW= 13773.10 if year==81;
replace AW= 14531.34 if year==82;
replace AW= 15239.24 if year==83;
replace AW= 16135.07 if year==84;
replace AW= 16822.51 if year==85;
replace AW= 17321.82 if year==86;
replace AW= 18426.51 if year==87;
replace AW= 19334.04 if year==88;
replace AW= 20099.55 if year==89;
replace AW= 21027.98 if year==90;
replace AW= 21811.60 if year==91;
replace AW= 22935.42 if year==92;
replace AW= 23132.67 if year==93;
replace AW= 23753.53 if year==94;
replace AW= 24705.66 if year==95;
replace AW= 25913.90 if year==96;
replace AW= 27426.00 if year==97;
replace AW=  28861.44 if year==98;
replace AW=  30469.84 if year==99;
replace AW=  32154.82 if year==00;
replace AW=  32921.92 if year==01;


* this is the taxable maximum;
* from http://www.ssa.gov/OACT/COLA/cbb.html;
gen incmax=.;

replace incmax= 3000 if year>=37 & year<=50;
replace incmax= 3600 if year>=51 & year<=54;
replace incmax= 4200 if year>=55 & year<=58;
replace incmax= 4800 if year>=59 & year<=65;
replace incmax= 6600 if year>=66 & year<=67;
replace incmax= 7800 if year>=68 & year<=71;
replace incmax= 9000 if year==72;
replace incmax= 10800 if year==73;
replace incmax= 13200 if year==74;
replace incmax= 14100 if year==75;
replace incmax= 15300 if year==76;
replace incmax= 16500 if year==77;
replace incmax= 17700 if year==78;
replace incmax= 22900 if year==79;
replace incmax= 25900 if year==80;
replace incmax= 29700 if year==81;
replace incmax= 32400 if year==82;
replace incmax=  35700 if year==83;
replace incmax=  37800 if year==84;
replace incmax=  39600 if year==85;
replace incmax=  42000 if year==86;
replace incmax=  43800 if year==87;
replace incmax=  45000 if year==88;
replace incmax=  48000 if year==89;
replace incmax=  51300 if year==90;
replace incmax=  53400 if year==91;
replace incmax=  55500 if year==92;
replace incmax=  57600 if year==93;
replace incmax=  60600 if year==94;
replace incmax=  61200 if year==95;
replace incmax=   62700 if year==96;
replace incmax=   65400 if year==97;
replace incmax=   68400 if year==98;
replace incmax=   72600 if year==99;
replace incmax=  76200 if year==100;
replace incmax=   80400 if year==101;
replace incmax=   84900 if year==102;
replace incmax=   87000 if year==103;

gen pce = .;

replace pce= 18.85 if year==51;
replace pce= 19.23 if year==52;
replace pce= 19.5 if year==53;
replace pce= 19.68 if year==54;
replace pce= 19.76 if year==55;
replace pce= 20.16 if year==56;
replace pce= 20.77 if year==57;
replace pce= 21.29 if year==58;
replace pce= 21.63 if year==59;
replace pce= 22 if year==60;
replace pce= 22.23 if year==61;
replace pce= 22.49 if year==62;
replace pce= 22.75 if year==63;
replace pce= 23.07 if year==64;
replace pce= 23.41 if year==65;
replace pce= 24.02 if year==66;
replace pce= 24.62 if year==67;
replace pce= 25.58 if year==68;
replace pce= 26.74 if year==69;
replace pce= 28 if year==70;
replace pce= 29.2 if year==71;
replace pce= 30.22 if year==72;
replace pce= 31.86 if year==73;
replace pce= 35.14 if year==74;
replace pce= 38.01 if year==75;
replace pce= 40.08 if year==76;
replace pce= 42.73 if year==77;
replace pce= 45.78 if year==78;
replace pce= 49.83 if year==79;
replace pce= 55.21 if year==80;
replace pce= 60.08 if year==81;
replace pce= 63.48 if year==82;
replace pce= 66.19 if year==83;
replace pce= 68.63 if year==84;
replace pce= 70.99 if year==85;
replace pce= 72.72 if year==86;
replace pce= 75.49 if year==87;
replace pce= 78.44 if year==88;
replace pce= 81.86 if year==89;
replace pce= 85.63 if year==90;
replace pce= 88.91 if year==91;
replace pce= 91.62 if year==92;
replace pce= 93.81 if year==93;
replace pce= 95.7 if year==94;
replace pce= 97.9 if year==95;
replace pce= 100 if year==96;
replace pce= 101.94 if year==97;
replace pce=  103.03 if year==98;
replace pce=  104.73 if year==99;
replace pce=  107.39 if year==100;
replace pce=  109.56 if year==101;
* the price index that I am using elsewhere is for 1998=100;
replace pce=pce/103.03;

* This is for the bend points in the formula for mapping AIME to PIA;
gen bendyear=91; * decide on the year to use for benefits;
gen bend1=.;
gen bend2=.;
replace bend1=370 if bendyear==91;
replace bend2=2230 if bendyear==91;
replace bend1=387 if bendyear==92;
replace bend2=2333 if bendyear==92;
replace bend1=401 if bendyear==93;
replace bend2=2420 if bendyear==93;
replace bend1=422 if bendyear==94;
replace bend2=2545 if bendyear==94;
replace bend1=426 if bendyear==95;
replace bend2=2567 if bendyear==95;
replace bend1=437 if bendyear==96;
replace bend2=2635 if bendyear==96;
replace bend1=455 if bendyear==97;
replace bend2=2741 if bendyear==97;
replace bend1=477 if bendyear==98;
replace bend2=2875 if bendyear==98;

replace bend1=bend1*12; * convert to annual amounts;
replace bend2=bend2*12;

gen AWfac=.;
replace AWfac= 21811.60 if bendyear==91;
replace AWfac= 22935.42 if bendyear==92;
replace AWfac= 23132.67 if bendyear==93;
replace AWfac= 23753.53 if bendyear==94;
replace AWfac= 24705.66 if bendyear==95;
replace AWfac= 25913.90 if bendyear==96;
replace AWfac= 27426.00 if bendyear==97;
replace AWfac=  28861.44 if bendyear==98;
replace AWfac=  30469.84 if bendyear==99;
replace AWfac=  32154.82 if bendyear==100;
replace AWfac=  32921.92 if bendyear==101;


save C:\HRS\SSA3\STATA\restrict1, replace;
log close ;
program drop _all ;
*drop _all ;

