# delimit ;
 set more 1 ;
log using C:\HRS\SSA3\STATA\restrict2.log, replace ;
drop _all;



use C:\HRS\SSA3\STATA\restrict1; 
* fix the memory type;
sort HHIDPN;
gen long temp=real(HHIDPN);

drop HHIDPN;
gen long HHIDPN=temp;
sort HHIDPN;


*generate totalquarter=sum of all quarters of coverage for each person;

egen qrttotal= total(qcs), by(HHIDPN); 
sum qrttotal;

*Generate AIME=sum of earnings in all years for each individual/35;
* NEED TO MAKE AN ADJUSTMENT TO EARNINGS, IF SOMEONE HAS MORE THAN 35 YEARS OF EARNINGS, SET EARNINGS IN YEARS OTHER THAN THE BEST 35 EQUAL TO 0;
*Making an adjustment for those who worked for more than 35 years;
gen index=earn/AW;

sort index;
gen posearn=0;
replace posearn=1 if index>0 & index~=.;
egen earntotal= total(posearn), by(HHIDPN); 
sum earntotal;

gen ones=1;
egen years= total(ones), by(HHIDPN); 
sum years; * this should always equal 41, becuase we obserrve SS earnings for the years 1951-1991;

*generate a percentage of lowest income that needs to be excluded;
gen cutoff=((years-35)/years) ;  * fraction of years that should be dropped;

by HHIDPN, sort: cumul index, gen(percent) ;
replace index=0 if percent<=cutoff; 

egen AIMEtot=total(index), by(HHIDPN);

/* calculate AIME two ways */
*1 => best 35 years in the lf, 0s for non working years (method for benefit calc, if the individ claims normal benefits;
gen AIME=AIMEtot/35; * this is the default;
* 2 => average over all years worked, drop non-working years (method of benefit calc if the individual is grawing DI);
*gen AIME=AIMEtot/earntot;

* now adjust earnings by the relevant average wage factor -- should be for 1991;
replace AIME=AIME*AWfac;


* generate PIA as a function of AIME;
gen K1=.9*bend1;
gen K2=K1+.32*(bend2-bend1);
gen PIAest=.9*AIME if AIME<bend1;
replace PIAest=K1 + .32*(AIME-bend1) if AIME>=bend1 & AIME<bend2;
replace PIAest = K2+ .15*(AIME-bend2) if AIME>=bend2; * by construction, this should be below the maximum level, but worth checking;
drop K1 K2;

replace pia=pia*12;

drop if year~=91; * for the initial conditions, we only care about total years of work, AIME, which is summaraized in the 1991 value; 


* bunch of variables I do not need;
drop year type qcs incmax pce bend* AWfac index cutoff AIMEtot pia temp*;
sort HHIDPN;
save C:\HRS\SSA3\STATA\restrict2, replace;

log close ;
program drop _all ;
*drop _all ;

