# delimit ;
 set more 1 ;
drop _all;
capture log close;
log using C:\HRS\SSA3\STATA\restrict3.log, replace ;

set mem 500m;


*use C:\HRS\SSA3\STATA\awhdist_noseed; * males from hrs, aged 51-55, estimation sample;
*use C:\HRS\SSA3\STATA\awhdist_noseed2; * males from hrs, aged 51-55, estimation sample;
*use C:\HRS\SSA3\STATA\awhdist_seed; * males from hrs, aged 51-55, estimation sample;
*use C:\HRS\SSA3\STATA\awhdist_seed2; * males from hrs, aged 51-55, estimation sample;
use C:\HRS\SSA3\STATA\awhdistX_seed;


*use C:\HRS\SSA3\STATA\temp; * all hrs and ahead people;

gen long temp1 = HHID;
gen long temp2 =PN;
gen long temp3= 1000*temp1+temp2;
gen long HHIDPN=temp3;

* merge resticted data to awhdist file;
sort HHIDPN;
merge HHIDPN using C:\HRS\SSA3\STATA\restrict2;
tab _merge;


* consider the following drops;
sort HHIDPN;
*drop if HHIDPN==HHIDPN[_n-1]; * drop repeated obs on same person? -- No, I think the multiple obs do provide info;
*this gives 8,214 with _merge=1, i.e., this many obs come frm the master dataset -- temp
sum;
tab _merge;
drop if _merge==2; * get rid of SSA observations that we do not need;
drop _merge;

* indicator for whether someone is in the core HRS cohort;
gen hrs=0;
replace hrs=1 if HHID<100000;
drop if hrs~=1;
sum;


********impute llfpr, using SSA histories and current lfpr to guess;
drop posearn;
gen posearn=.;
replace posearn=0 if earn>-10 & earn<1000;
replace posearn=1 if earn>999 & earn<100000;
replace llfpr=posearn if wave==1 & llfpr==.;
sort wave;
by wave: sum *lfpr;
replace llfpr= lfpr if llfpr==.; * we only need llfpr, not lfpr, and last period's lfpr is highly correlated with this period's;

* now merge to pension calculator information;
sort HHIDPN;
merge HHIDPN using C:\Pension\pension3;
tab _merge;
drop if _merge==2; *get rid of pension obs for women, out of age range;
drop _merge;

***************some imputations here--use pension calculator data if unrestricted data are missing**********;
replace earn=WageCurr if earn==.;
replace earnlast=WageLast if earnlast==.;
replace earnprev=WagePrev if earnprev==.;

replace tenure=TenureCurr if tenure==.;
replace tenurelast=TenureLast if tenurelast==.;
replace tenureprev=TenurePrev if tenureprev==.;



sum;
sort HHIDPN;
order HHIDPN Calcpen* AIME assets; 

sum HHIDPN Calcpen* AIME assets wage assets healw instype lfpr AIME qrttotal;

save C:\HRS\SSA3\STATA\restrict3, replace;
log close ;
program drop _all ;
*drop _all ;

