# delimit ; 
set more 1;
capture log close;
drop _all;
use "C:\HRS\SSA3\STATA\workage.dta", clear;
log using C:\HRS\SSA3\STATA\retire_final.log, replace;

******a couple of drops to be consistent with restrict4 *******;
drop if instiew1==.;  
drop if ((CalcpenCurr>1000000 & CalcpenCurr~=.)|(CalcpenLast>1000000 & CalcpenLast~=.)|(CalcpenPrev>1000000 & CalcpenPrev~=.)) & (SScov~=5|Govt~=5);

gen doHI=0;

*drop if birthyr>1935;
gen age1=age-60;
gen long indnum = HHIDPN;
gen epinsw1=eprhiw1+instiew1;
gen insnonew1=1-epinsw1;

gen realyear=year;
replace realyear=102 if wave==6;
replace realyear=104 if wave==7;

replace realyear=93 if wave==102;
replace realyear=95 if wave==103;
replace realyear=97 if wave==104;
replace realyear=99 if wave==105;
replace realyear=101 if wave==106;
replace realyear=103 if wave==107;

replace realyear=92.5 if wave==202;
replace realyear=94.5 if wave==203;
replace realyear=96.5 if wave==204;
replace realyear=98.5 if wave==205;
replace realyear=100.5 if wave==206;
replace realyear=102.5 if wave==207;

* get wage data for missings/non-workers;
* already taken care of;
/*sort HHID PN realyear;
replace wage=wage[_n-1] if indnum==indnum[_n-1] & wage==.;
replace wagelast=wagelast[_n-1] if indnum==indnum[_n-1] & wagelast==.;
replace wage=wagelast if wage==.;
replace wage=wagew1 if wage==.;
gen wagemiss=0;
replace wagemiss=1 if wage==.;
replace wage=1 if wagemiss==1;
replace healw=healw[_n-1] if indnum==indnum[_n-1] & healw==.;
*/

sort wave;
by wave: sum  V5009 ;


foreach var in V3319 V5009 V9063 wage assets healw age1 V3319zero V5009zero insnonew1 instiew1{;

foreach var2 in V3319 V5009 V9063 wage assets healw age1 V3319zero V5009zero insnonew1 instiew1{;

  gen `var'`var2' = `var'*`var2';

};

};

drop age1age1;

foreach var in AIME trueDBcurr trueDCcurr trueDBlast trueDClast trueDBprev trueDCprev penDBcurrT penDCcurrT age1{;

foreach var2 in AIME trueDBcurr trueDCcurr trueDBlast trueDClast trueDBprev trueDCprev penDBcurrT penDCcurrT age1{;

  gen `var'`var2' = `var'*`var2';

};

};

*gen age1=age;
gen age2=age1*age1;
gen age3=age2*age1;
gen age4=age3*age1;
gen age5=age4*age1;
gen age6=age5*age1;
gen age7=age6*age1;
gen age8=age7*age1;
gen age9=age8*age1;
gen age10=age9*age1;
gen age11=age10*age1;
gen age12=age11*age1;
gen age13=age12*age1;


tab V3319zero lfpr if realyear>97;



if doHI==0 {;

* sample selection;
drop if (realyear>93 & doHI==1);
drop if (realyear<98 & doHI==0);
replace epinsw1=lfpr if doHI==0;

* drop the missings and see what we have left;
drop if (V5009==.|epins==.|age>69);
drop if wage==.;
drop if assets==.;
drop if age==.;
drop if healw==.;



tab V3319zero lfpr if realyear>97;


/******* basic specification *************************/

local a = "wage wagemiss assets healw age1 age2 age3 age4 age5";
local b = "V3319 V5009 V9063 V3319zero V5009miss V9063miss";
local c = "insnonew1 instiew1 insnonew1age1 instiew1age1";
local d = "wagewage  wageassets age1wage age1assets age1healw ";
local e = "V3319V3319 V5009V5009 V9063V9063";
*local f = "AIME trueDBcurr trueDCcurr trueDBlast trueDClast trueDBprev trueDCprev";
*local g = "AIMEage1 trueDBcurrage1 trueDCcurrage1 trueDBlastage1 trueDClastage1 trueDBprevage1 trueDCprevage1";
*local h = "penDBcurrT penDCcurrT penDBcurrTage1 penDCcurrTage1";

local f = "";
local g = "";
local h = "";



/*
probit lfpr V3319zero;


probit lfpr `a' `b' `c' `d' `e';
mfx compute;

probit lfpr `a' `b' `c' `d' ;
mfx compute;

probit lfpr `a' `b' `c';
mfx compute;

probit lfpr `a' `c';
mfx compute;

*/

*drop if lfprw1~=1;
* basic specification;
reg lfpr `a' `c' `d' lfprw1; 
test instiew1 instiew1age1;
display r(p);
* basic specification, includes pension coverage;
reg lfpr `a' `c' `d' `h' lfprw1 ; 
* include restricted data, no preference variables;
reg lfpr `a' `c' `d' `f' `g' `h' lfprw1; 
* no restricted data, include preference variables;
reg lfpr `a' `b' `c' `d' `h' lfprw1  ; 
* include everything;
reg lfpr `a' `b' `c' `d' `f' `g' `h' lfprw1 ; 
test `b' ;
display r(p);
test instiew1 instiew1age1;
display r(p);

*******************************************************************;
*******************************************************************;
*******************************************************************;

reg V3319 `a' `c' `d' `f' `g' `h' ; 
predict V3319pred;
gen V3319res=V3319-V3319pred;

reg V5009 `a' `c' `d' `f' `g' `h'  ; 
predict V5009pred;
gen V5009res=V5009-V5009pred;


reg V9063 `a' `c' `d' `f' `g' `h'  ; 
predict V9063pred;
gen V9063res=V9063-V9063pred;

reg V3319zero `a' `c' `d' `f' `g' `h'  ; 
predict V3319zeropred;
gen V3319zerores=V3319zero-V3319zeropred;

reg V5009miss `a' `c' `d' `f' `g' `h' ; 
predict V5009misspred;
gen V5009missres=V5009miss-V5009misspred;

reg V9063miss `a' `c' `d' `f' `g' `h'  ; 
predict V9063misspred;
gen V9063missres=V9063miss-V9063misspred;


reg lfprw1 `a' `c' `d' `f' `g' `h'  ; 
predict lfprw1pred;
gen lfprw1res=lfprw1-lfprw1pred;

reg lfpr `a' `c' `d' `f' `g' `h'  ; 
predict lfprpred;
gen lfprres=lfpr-lfprpred;

replace lfpr=lfprres;
replace V3319 =V3319res;
replace V5009=V5009res;
replace V9063=V9063res;
replace V3319zero=V3319zerores;
replace V5009miss=V5009missres;
replace V9063miss=V9063missres;
replace lfprw1=lfprw1res;

reg lfpr V3319 V5009 V9063 V3319zero V5009miss V9063miss lfprw1;



gen bV3319=_b[V3319];
gen bV9063=_b[V9063];
gen bV5009=_b[V5009];
gen bV3319zero=_b[V3319zero];
gen bV9063miss=_b[V9063miss];
gen bV5009miss=_b[V5009miss];
gen blfprw1=_b[lfprw1];

foreach var in V3319 V9063 V5009 V3319zero V9063miss V5009miss lfprw1 {;
  qui sum `var';
  gen `var'I = b`var'*r(mean);
	gen `var'c=b`var'*`var';
};

gen pref_index=V3319c+V9063c+V5009c+V3319zeroc+V9063missc+V5009missc+lfprw1c;
sort HHID PN realyear;
drop if HHID==HHID[_n-1] & PN==PN[_n-1];


gen AV_index=V3319I+V9063I+V5009I+V3319zeroI+V9063missI+V5009missI+lfprw1I;

drop if _n>1;

gen oner =1;
sort oner;


*save C:\HRS\SSA3\STATA\prefs, replace;

keep bV3319 bV9063 bV5009 bV3319zero bV9063miss bV5009miss blfprw1 AV_index oner;
order bV3319 bV9063 bV5009 bV3319zero bV9063miss bV5009miss blfprw1 AV_index oner;

save C:\HRS\SSA3\STATA\prefweights, replace;
outsheet using C:\HRS\SSA3\STATA\prefweights,nonames replace;


log close;
exit;


