# delimit ; 
clear; 
set mem 300m;	
set more 1 ;  
drop _all;
program drop _all;
capture log close;
log using C:\research\hrs\dist\healdist.log, replace ; 
*log using c:\hrs\healdist.log, replace;
* here I estimate the distributions of health costs;
program drop _all;

*****************;
* program sigsqmu;
* decide what percentile to match: picking 95th now;
program define sigsqmu;
local i=1;
while `i' <=20 {


sum test*;


  gen var`i'= test`i';


egen obs2`i' = count(var`i');
  summ var`i';
  gen pr_M`i'=.95;
  means var`i';
    gen m`i'= ln(r(mean));
      summ m`i';
  gen z_M`i'=invnorm(pr_M`i');
      summ z_M`i';  
  _pctile var`i', p(95);
    gen pct`i'=r(r1);
      summ pct`i';
  gen y_M`i'=ln(pct`i');
      summ y_M`i';



sum z_M`i' y_M`i' m`i';
*the command below is pretty sketchy -think about how to deal with the problem;
gen z_MM`i' = z_M`i';
replace z_MM`i'= (sqrt(2*(y_M`i'-m`i'))+.0001) if z_M`i'-sqrt(2*(y_M`i'-m`i'))<0;
sum z_MM`i' y_M`i' m`i';

  gen sigsq`i'=z_MM`i' - sqrt(z_MM`i'^2-2*(y_M`i'-m`i'));
  replace sigsq`i'=sigsq`i'^2; 
  gen mu`i'= m`i'-sigsq`i'/2;
  gen mu2`i' = exp(mu`i'+sigsq`i'/2);
  gen pct2`i' = exp(mu`i'+sqrt(sigsq`i')*z_M`i');

* Eric's addition for medicaid ;
gen mu2x`i'=mu2`i'+medcd`i'*10000;
gen mux`i'=ln(mu2x`i'/mu2`i');
gen pct2x`i'=exp(mux`i' + mu`i' + sqrt(sigsq`i')*z_M`i');
gen chk`i' = exp(mux`i' + mu`i' + (sigsq`i'/2));

* generate individual level medical expense data, adjusted for medicaid;
replace varx=var`i'*exp(mux`i') if (var`i'~=.& `i'<11);

* adjust household size so that it is a constant size;
gen mu2xx`i'=mu2x`i'*(hhmean/hh`i');
gen pct2xx`i'=pct2x`i'*(hhmean/hh`i');

summ sigsq`i' mu`i' mux`i' mu2`i' mu2x`i' mu2xx`i' pct2`i' pct2x`i' pct2xx`i' obs2`i' chk`i';

* keep only the medicaid adjusted data;
drop mu`i' mu2`i' pct2`i' chk`i' mu2x`i' pct2x`i';
rename mux`i' mu`i';
rename mu2xx`i' mu2`i';
rename pct2xx`i' pct2`i';

  local i=`i'+1;};

end;

****************;
* prgram genvars;
program define genvars;


* for the medicaid adjustemnts;
replace insmedcd=0 if lmedcost~=. & insmedcd==.;
replace insmedcd=. if lmedcost==.;

**********************************************;
* first code up costs ************************;
**********************************************;
* age<65, health insurance type;
gen lmclrety=lmedcost if leprhi==1 & age<65;
gen lmclretwy=lmedcost if leprhi==1 & lfpr==1 & age<65;
gen lmclretny=lmedcost if leprhi==1 & lfpr==0 & age<65;
gen lmcltiey=lmedcost if linstie==1 & lfpr==1 & age<65;
gen lmclcoby=lmedcost if linstie==1 & lfpr==0 & age<65;
gen lmclnony=lmedcost if linsnone==1 & age<65;

sum lmclnony;

* age>=65, health insurance type;
gen lmclreto=lmedcost if leprhi==1 & age>=65;
gen lmclretwo=lmedcost if leprhi==1 & lfpr==1 & age>=65;
gen lmclretno=lmedcost if leprhi==1 & lfpr==0 & age>=65;
gen lmcltieo=lmedcost if linstie==1 & lfpr==1 & age>=65;
gen lmclcobo=lmedcost if linstie==1 & lfpr==0 & age>=65;
gen lmclnono=lmedcost if linsnone==1 & age>=65;
gen lmcltoto = lmedcost if age>=65;

* age>=65, age<agesplit health insurance type;
gen lmclretm=lmedcost if leprhi==1 & age>=65 & age<agesplit;

gen lmclretwm=lmedcost if leprhi==1 & lfpr==1 & age>=65 & age<agesplit;
gen lmclretnm=lmedcost if leprhi==1 & lfpr==0 & age>=65 & age<agesplit;
gen lmcltiem=lmedcost if linstie==1 & lfpr==1 & age>=65 & age<agesplit;
gen lmclcobm=lmedcost if linstie==1 & lfpr==0 & age>=65 & age<agesplit;
gen lmclnonm=lmedcost if linsnone==1 & age>=65 & age<agesplit;

* age>=agesplit, health insurance type;
gen lmclretv=lmedcost if leprhi==1 & age>= agesplit;
gen lmclretwv=lmedcost if leprhi==1 & lfpr==1 & age>= agesplit;
gen lmclretnv=lmedcost if leprhi==1 & lfpr==0 & age>= agesplit;
gen lmcltiev=lmedcost if linstie==1 & lfpr==1 & age>= agesplit;
gen lmclcobv=lmedcost if linstie==1 & lfpr==0 & age>= agesplit;
gen lmclnonv=lmedcost if linsnone==1 & age>= agesplit;

****************************************;
* now code up medicaid *****************;
****************************************;

* age<65, health insurance type;
gen medrety=insmedcd if leprhi==1 & age<65;
gen medretwy= insmedcd if leprhi==1 & lfpr==1 & age<65;
gen medretny= insmedcd if leprhi==1 & lfpr==0 & age<65;
gen medtiey= insmedcd if linstie==1 & lfpr==1 & age<65;
gen medcoby= insmedcd if linstie==1 & lfpr==0 & age<65;
gen mednony= insmedcd if linsnone==1 & age<65;

* age>=65, health insurance type;
gen medreto= insmedcd if leprhi==1 & age>=65;
gen medretwo= insmedcd if leprhi==1 & lfpr==1 & age>=65;
gen medretno= insmedcd if leprhi==1 & lfpr==0 & age>=65;
gen medtieo= insmedcd if linstie==1 & lfpr==1 & age>=65;
gen medcobo= insmedcd if linstie==1 & lfpr==0 & age>=65;
gen mednono= insmedcd if linsnone==1 & age>=65;
gen medtoto = insmedcd if age>=65;

* age>=65, age<agesplit, health insurance type;
gen medretm= insmedcd if leprhi==1 & age>=65 & age<agesplit;
gen medretwm= insmedcd if leprhi==1 & lfpr==1 & age>=65 & age<agesplit;
gen medretnm= insmedcd if leprhi==1 & lfpr==0 & age>=65 & age<agesplit;
gen medtiem= insmedcd if linstie==1 & lfpr==1 & age>=65 & age<agesplit;
gen medcobm= insmedcd if linstie==1 & lfpr==0 & age>=65 & age<agesplit;
gen mednonm= insmedcd if linsnone==1 & age>=65& age<agesplit;

* age>=agesplit, health insurance type;
gen medretv= insmedcd if leprhi==1 & age>= agesplit;
gen medretwv= insmedcd if leprhi==1 & lfpr==1 & age>= agesplit;
gen medretnv= insmedcd if leprhi==1 & lfpr==0 & age>= agesplit;
gen medtiev= insmedcd if linstie==1 & lfpr==1 & age>= agesplit;
gen medcobv= insmedcd if linstie==1 & lfpr==0 & age>= agesplit;
gen mednonv= insmedcd if linsnone==1 & age>= agesplit;

*********************************************;
* household size ****************************;
*********************************************;

* age<65, health insurance type;
gen hhrety=hhsize if leprhi==1 & age<65;
gen hhretwy= hhsize if leprhi==1 & lfpr==1 & age<65;
gen hhretny= hhsize if leprhi==1 & lfpr==0 & age<65;
gen hhtiey= hhsize if linstie==1 & lfpr==1 & age<65;
gen hhcoby= hhsize if linstie==1 & lfpr==0 & age<65;
gen hhnony= hhsize if linsnone==1 & age<65;

* age>=65, health insurance type;
gen hhreto= hhsize if leprhi==1 & age>=65;
gen hhretwo= hhsize if leprhi==1 & lfpr==1 & age>=65;
gen hhretno= hhsize if leprhi==1 & lfpr==0 & age>=65;
gen hhtieo= hhsize if linstie==1 & lfpr==1 & age>=65;
gen hhcobo= hhsize if linstie==1 & lfpr==0 & age>=65;
gen hhnono= hhsize if linsnone==1 & age>=65;
gen hhtoto = hhsize if age>=65;

* age>=65, age<agesplit, health insurance type;
gen hhretm= hhsize if leprhi==1 & age>=65 & age<agesplit;
gen hhretwm= hhsize if leprhi==1 & lfpr==1 & age>=65 & age<agesplit;
gen hhretnm= hhsize if leprhi==1 & lfpr==0 & age>=65 & age<agesplit;
gen hhtiem= hhsize if linstie==1 & lfpr==1 & age>=65 & age<agesplit;
gen hhcobm= hhsize if linstie==1 & lfpr==0 & age>=65 & age<agesplit;
gen hhnonm= hhsize if linsnone==1 & age>=65& age<agesplit;

* age>=agesplit, health insurance type;
gen hhretv= hhsize if leprhi==1 & age>= agesplit;
gen hhretwv= hhsize if leprhi==1 & lfpr==1 & age>= agesplit;
gen hhretnv= hhsize if leprhi==1 & lfpr==0 & age>= agesplit;
gen hhtiev= hhsize if linstie==1 & lfpr==1 & age>= agesplit;
gen hhcobv= hhsize if linstie==1 & lfpr==0 & age>= agesplit;
gen hhnonv= hhsize if linsnone==1 & age>= agesplit;



summ lmed* lmc* med*;

gen test1= exp(lmclretwy);
gen test2= exp(lmclretny);
gen test3= exp(lmcltiey);
gen test4= exp(lmclcoby);
gen test5= exp(lmclnony);
gen test6= exp(lmclretwo);
gen test7= exp(lmclretno);
gen test8= exp(lmcltieo);
gen test9= exp(lmclcobo);
gen test10=exp(lmclnono);
gen test11= exp(lmclretwm);
gen test12= exp(lmclretnm);
gen test13= exp(lmcltiem);
gen test14= exp(lmclcobm);
gen test15= exp(lmclnonm);
gen test16= exp(lmclretwv);
gen test17= exp(lmclretnv);
gen test18= exp(lmcltiev);
gen test19= exp(lmclcobv);
gen test20=exp(lmclnonv);

egen medcd1= mean(medretwy);
egen medcd2= mean(medretny);
egen medcd3= mean(medtiey);
egen medcd4= mean(medcoby);
egen medcd5= mean(mednony);
egen medcd6= mean(medretwo);
egen medcd7= mean(medretno);
egen medcd8= mean(medtieo);
egen medcd9= mean(medcobo);
egen medcd10= mean(mednono);
egen medcd11= mean(medretwm);
egen medcd12= mean(medretnm);
egen medcd13= mean(medtiem);
egen medcd14= mean(medcobm);
egen medcd15= mean(mednonm);
egen medcd16= mean(medretwv);
egen medcd17= mean(medretnv);
egen medcd18= mean(medtiev);
egen medcd19= mean(medcobv);
egen medcd20= mean(mednonv);

egen hh1= mean(hhretwy);
egen hh2= mean(hhretny);
egen hh3= mean(hhtiey);
egen hh4= mean(hhcoby);
egen hh5= mean(hhnony);
egen hh6= mean(hhretwo);
egen hh7= mean(hhretno);
egen hh8= mean(hhtieo);
egen hh9= mean(hhcobo);
egen hh10= mean(hhnono);
egen hh11= mean(hhretwm);
egen hh12= mean(hhretnm);
egen hh13= mean(hhtiem);
egen hh14= mean(hhcobm);
egen hh15= mean(hhnonm);
egen hh16= mean(hhretwv);
egen hh17= mean(hhretnv);
egen hh18= mean(hhtiev);
egen hh19= mean(hhcobv);
egen hh20= mean(hhnonv);


if allheal==0 {;
*bomb;
};

replace hhsize=. if hhretwy==. & hhretny==. & hhtiey==. & hhcoby==. & hhnony==. & hhretwo==. & hhretno==. & hhtieo==. & hhcobo==. & hhnono==. & hhretwm==. & hhretnm==. & hhtiem==. & hhcobm==. & hhnonm==. & hhretwv==. & hhretnv==. & hhtiev==. & hhcobv==. & hhnonv==.;

egen hhmean=mean(hhsize);

sum test* medcd* hh*;
sum hhsize if age<65;
sum hhsize if age>64 & age<agesplit;
sum hhsize if age>=agesplit;



gen varx=.;
sigsqmu;




_pctile varx, p(99.5);
gen pct995=r(r1);
_pctile varx, p(99);
gen pct99=r(r1);
_pctile varx, p(95);
gen pct95=r(r1);
_pctile varx, p(90);
gen pct90=r(r1);
sum pct*;

sort indnum age ;
drop if ((indnum>indnum[_n-1])|(age>age[_n-1])) & (indnum[_n-1]~=.);

if allheal==1 {;
save C:\research\hrs\dist\meds, replace;
};

keep 
mu21 mu22 mu23 mu24 mu25 mu26 mu27 mu28 mu29 mu210 
mu211 mu212 mu213 mu214 mu215 mu216 mu217 mu218 mu219 mu220 
obs21 obs22 obs23 obs24 obs25 obs26 obs27 obs28 obs29 obs210
obs211 obs212 obs213 obs214 obs215 obs216 obs217 obs218 obs219 obs220 
pct21 pct22 pct23 pct24 pct25 pct26 pct27 pct28 pct29 pct210 
pct211 pct212 pct213 pct214 pct215 pct216 pct217 pct218 pct219 pct220;

order 
mu21 mu22 mu23 mu24 mu25 mu26 mu27 mu28 mu29 mu210 
mu211 mu212 mu213 mu214 mu215 mu216 mu217 mu218 mu219 mu220 
obs21 obs22 obs23 obs24 obs25 obs26 obs27 obs28 obs29 obs210
obs211 obs212 obs213 obs214 obs215 obs216 obs217 obs218 obs219 obs220 
pct21 pct22 pct23 pct24 pct25 pct26 pct27 pct28 pct29 pct210 
pct211 pct212 pct213 pct214 pct215 pct216 pct217 pct218 pct219 pct220;
sum;
end;
* end of genvars ;


use C:\research\hrs\merge\merge7a;
drop if wave==1;
drop if male~=1;
drop if wave>6;

*bomb;

drop if (age<55|age>84);



*sum medcost married insmed* if healw==0 & linstiexx==1 & lfpr==0 & age>74;
*bomb;



gen agesplit=75; * set at either 70 or 75;
replace married=0 if married==.;
gen hhsize=1+married;
* what measurement error correction would you like to use?;
* note: I think only "2" will work;
* meas=0 => measurement error corrections and use first observed health insurance;
* meas=1 => raw data (no measurement error corrections, last period's health insurance;
* meas=2 => no measurement error corrections, use first observed health insurance;   
* meas=3 => measurement error corrections, last period's health insurance;
* meas==4 => use current health insurance;
gen meas=2; 


replace linsnone=linsnonex if meas==1;
replace leprhi=leprhix if meas==1;
replace linstie=linstiex if meas==1;

replace linsnone=linsnonexx if meas==2;
replace leprhi=leprhixx if meas==2;
replace linstie=linstiexx if meas==2;

replace linsnone=linsnonexxx if meas==3;
replace leprhi=leprhixxx if meas==3;
replace linstie=linstiexxx if meas==3;

replace linsnone=insnone if meas==4;
replace leprhi=eprhi if meas==4;
replace linstie=instie if meas==4;


sum medc* if age<65 & linsnone==1;


* selection criteria ;
*drop if linsnone==.|leprhi==.|linstie==.;
drop if medcost==.;
drop if hhsize==.;
drop if age<55;
drop if age>90; * experiment with this one -I now use the age 80+ guys;
* drop if (linsnone==.|leprhi==.|linstie==.); * does this do anything? ;
drop if medcost==.;

************************************************;
* Phil: do everything here                      ;
*replace insmedcd=0;
*replace hhsize=2;




sort dead;
by dead: sum medcost;

rename _medcost _medc;
replace _medc=0 if dead==1|_dead==1 & _medc==.;
replace _iprem=0 if dead==1|_dead==1 & _iprem==.;

replace medcost=medcost+_medc;
replace iprem=iprem+_iprem;
drop if iprem>30000 & iprem~=.;


* estimate mean and variance of total log medical costs for those whose costs are greater than zero;
replace medcost=250 if medcost<250;
gen lmedcost=ln(medcost);
drop if medcost==.;
sort dead;
by dead: sum med* healw;
sort wave;
by wave: summ _medc* _oop _drugc _iprem medc*;
sort age;
by age: sum medc* hhsize linsnone linstie leprhi;



save C:\research\hrs\dist\healdist, replace;


use C:\research\hrs\dist\healdist, replace;

gen allheal=1;
genvars;

saveold C:\research\gauss\healdn\crossvar, replace;
outsheet using C:\research\gauss\healdn\crossvar,nonames replace;
drop _all;

use C:\research\hrs\dist\healdist, replace;
*use c:\hrs\healdist, replace;
drop if healw~=1;
gen allheal=0;
genvars;


saveold C:\research\gauss\healdn\crossbad, replace;
outsheet using C:\research\gauss\healdn\crossbad,nonames replace;
drop _all;

use C:\research\hrs\dist\healdist, replace;
drop if healw~=0;
gen allheal=0;
genvars;


saveold C:\research\gauss\healdn\crossgd, replace;
outsheet using C:\research\gauss\healdn\crossgd,nonames replace;
drop _all;

drop _all;
program drop _all;
log close;
