# delimit ;  
set more 1 ;  
local UNIX 0;

if `UNIX' == 0  {; 
         local saved  "c:\research\hrs\merge\";
         local wave1d "c:\research\hrs\wave1\";
         local wave2d "c:\research\hrs\wave2\";
         local wave3d "c:\research\hrs\wave3\";
         local wave4d "c:\research\hrs\wave4\";
         local wave5d "c:\research\hrs\wave5\";
         local rand   "c:\research\hrs\rand\";
};

if `UNIX' == 1 {;
	local saved  "~/hrs/merge/";
	local wave1d "~/hrs/wave1/";
	local wave2d "~/hrs/wave2/";
	local wave3d "~/hrs/wave3/";
	local wave4d "~/hrs/wave4/";
	local wave5d "`/hrs/wave5/";
};


if `UNIX' == -1  {; 
         local saved  "C:\Documents and Settings\g1kak01\My Documents\hrs\merge\";
         local wave1d "C:\Documents and Settings\g1kak01\My Documents\hrs\wave1\";
         local wave2d "C:\Documents and Settings\g1kak01\My Documents\hrs\wave2\";
         local wave3d "C:\Documents and Settings\g1kak01\My Documents\hrs\wave3\";
         local wave4d "C:\Documents and Settings\g1kak01\My Documents\hrs\wave4\";
         local wave5d "C:\Documents and Settings\g1kak01\My Documents\hrs\wave5\";
         local rand   "C:\Documents and Settings\g1kak01\My Documents\hrs\rand\";
};

*recode asset and health insurance data;
log using "`saved'merge6.log", replace ;
use "`saved'merge5";
gen long hhidpn=HHID;
replace hhidpn=hhidpn*1000+PN;
rename hhidpn indnum;

/*
**this part of the code is for the robustness check for replacing assets with non-housingnon-business wealth ;
sort HHID PN realyear;
replace nhnbw=nhnbw[_n-1] if nhnbw==. & assets~=. & HHID==HHID[_n-1] & PN==PN[_n-1];
sum assets nhnbw;
replace assets=nhnbw;
*/


sort wave;
by wave: sum pen* ten* if wave<7;

* Recode missing pension variables;
gen same=.;
*replace same=same1 if wave==1;
replace same=same2 if wave==2;
replace same=same3 if wave==3;
replace same=same4 if wave==4;
replace same=same5 if wave==5;

sort HHID PN wave;
* this may not be cautious enough, because people can switch jobs;
replace pennage=pennage[_n-1] if pennage==. & HHID==HHID[_n-1] & PN==PN[_n-1] & lfpr==1 & same~=0 & wave<7;
replace peneage=peneage[_n-1] if peneage==. & HHID==HHID[_n-1] & PN==PN[_n-1] & lfpr==1 & same~=0 & wave<7;

replace penDBlast=penDBlast[_n-1] if penDBlast==. & HHID==HHID[_n-1] & PN==PN[_n-1] & wave<7;
replace penDBprev=penDBprev[_n-1] if penDBprev==. & HHID==HHID[_n-1] & PN==PN[_n-1] & wave<7;

replace penDClast=penDClast[_n-1] if penDClast==. & HHID==HHID[_n-1] & PN==PN[_n-1] & wave<7;
replace penDCprev=penDCprev[_n-1] if penDCprev==. & HHID==HHID[_n-1] & PN==PN[_n-1] & wave<7;

replace tenurelast=tenurelast[_n-1] if tenurelast==. & HHID==HHID[_n-1] & PN==PN[_n-1] & wave<7;
replace tenureprev=tenureprev[_n-1] if tenureprev==. & HHID==HHID[_n-1] & PN==PN[_n-1] & wave<7;

sort wave;
by wave: sum pen* ten* if wave<7;


******************************************************;
*recode health insurance data**************************;

gen insmedcd=0; * Medicaid health insurance;
replace insmedcd=1 if insgov==2; 

* assume that VA\CHAMPUS is the same as eprhi;
replace eprhi=1 if insgov==1; * VA\CHAMPUS; 
replace epins=1 if insgov==1; * VA\CHAMPUS;
replace eprhi=1 if inssp==1;

*generate a variable for health insurance tied to your job;
gen instie=.;
replace instie=1 if epins==1 & eprhi==0 & inssp==0;
replace instie=0 if epins==0|eprhi==1|inssp==1;

replace inssp=0 if eprhi==1;
replace insgov=0 if epins==1|inspriv==1; * recall that insgov=1 is just for VA\CHAMPUS coverage, insgov=2 is for Medicaid coverage;

gen insnone=.;
replace insnone=1 if epins==0 & insgov==0;
replace insnone=0 if epins==1|insgov==1|inssp==1;
replace inspriv=0 if epins==1|insgov==1;

replace insnone=1 if insmedcd==1;
replace insnone=1 if inspriv==1;



* get rid of extraneous insurance variables;
drop epfr eprfr;

******************************************************;
*recode spouse's health insurance data**************************;

gen _insmedcd=0; * Medicaid health insurance;
replace _insmedcd=1 if _insgov==2; 

replace _eprhi=1 if _insgov==1; * VA\CHAMPUS;
replace _epins=1 if _insgov==1; * VA\CHAMPUS;

replace _eprhi=1 if _inssp==1;

*generate a variable for health insurance tied to your job;
gen _instie=.;
replace _instie=1 if _epins==1 & _eprhi==0 & _inssp==0;
replace _instie=0 if _epins==0|_eprhi==1|_inssp==1;

replace _inssp=0 if _eprhi==1;
replace _insgov=0 if _epins==1|_inspriv==1; * recall that insgov=1 is just for VA\CHAMPUS coverage, insgov2 is for Medicaid coverage;

gen _insnone=.;
replace _insnone=1 if _epins==0 & _insgov==0;
replace _insnone=0 if _epins==1|_insgov==1|_inssp==1;
replace _inspriv=0 if _epins==1|_insgov==1;

replace _insnone=1 if _insmedcd==1;
replace _insnone=1 if _inspriv==1;



* generate wave 1 labor force participation and wage****************;

gen lfprw1=lfpr if wave==1;
sort HHID PN realyear;
replace lfprw1=lfprw1[_n-1] if HHID==HHID[_n-1] & PN==PN[_n-1];

gen wagew1=wage if wave==1;
replace wagew1=wagelast if wave==1 & wagew1==.;
sort HHID PN realyear;
replace wagew1=wagew1[_n-1] if HHID==HHID[_n-1] & PN==PN[_n-1];

gen eprhiw1=eprhi if wave==1;
sort HHID PN realyear;
replace eprhiw1=eprhiw1[_n-1] if HHID==HHID[_n-1] & PN==PN[_n-1];

gen instiew1=instie if wave==1;
sort HHID PN realyear;
replace instiew1=instiew1[_n-1] if HHID==HHID[_n-1] & PN==PN[_n-1];



***********************************;
/* 
for the preference heterogeneity cases, there are 3 important cases:
1: lfpr in wave 1=0 => V3319=0, V5009=0
2: lfpr in wave 1=1 => V3319>0, V5009=0 (I will never retire guys)
3: lfpr in wave 1=1 => V3319>0, V5009>0 
*/

* for most of the variables, higher numbers implies greater preference for work, but not all variables;
* make it so that for all variables, higher numbers implies greater preference for work;
replace V5018=5-V5018;
replace V5019=5-V5019;
replace V3319=5-V3319;
replace V3319=0 if V3319==5;

* for most observations, zeros/missing means that they did not work or it was a proxy interview;
* however, the ones below had zeros for reasons like being unmarried (and I want to keep those people);
replace V3319=0 if lfprw1==0;
gen V3319zero=0;
replace V3319zero = 1 if (V3319 == 0|V3319==.);
replace V3319=0 if V3319zero==1;

tab V3319zero lfprw1;
tab V3319zero lfpr if realyear>97;

* below is a good variable, but it is not used for the most part;
replace V9063=0 if V3319==0;
gen V9063zero=0;
replace V9063zero = 1 if (V9063 == 98| V9063==99 |V9063==.|V9063==0);
replace V9063=0 if V9063zero==1;
gen V9063miss=0;
replace V9063miss=1 if V3319zero==0 & V9063zero==1;

replace V5009=0 if V3319==0;
gen V5009zero=0;
replace V5009zero = 1 if (V5009 == 0|V5009==.);
replace V5009=0 if V5009zero==1;
gen V5009miss=0;
replace V5009miss=1 if V3319zero==0 & V5009zero==1;


*generate a single health variable;
gen healw=0;
replace healw=1 if heal==4|heal==5|dead==1;


gen age1= age;
drop if age<51;
drop if male~=1;
replace heal=5 if dead==1;
replace lfpr=0 if dead==1;


***********begin drop criteria for different age groups **********;
gen ageg=0;
replace ageg=1 if male==1 & hrscoh==1 & dead~=1 & birthyr>1930 & birthyr<1936 & age>50 & age<70;
replace ageg=2 if male==1 & hrscoh==1 & dead~=1 & birthyr>1935 & birthyr<1942 & age>50 & age<70;;


**********now we drop people *************;
************this lfpr criteria needs to be commented out for the med ex stuff, but these are the relevant criteria for the sample described in Appendix G;
*sort ageg;
*by ageg: sum lfpr healw;
*drop if lfpr==.;

sort ageg;
by ageg: sum lfpr healw;
drop if SScov==1 & SSYears>10;
sort ageg;
by ageg: sum lfpr lfprz;
drop if lfprw1==.;
sort ageg;
by ageg: sum lfpr;
drop if (heal==.|heal==8|heal==9); 
sort ageg;
by ageg: sum lfpr;
sort wave;
by wave: sum lfpr if ageg==1;
by wave: sum lfpr if ageg==2;

save "`saved'merge6", replace;

drop _all;
log close ;




