# delimit ;  set more 1 ;  set matsize 500;  

drop _all; 
program drop _all;
set mem 100m;

local DDrive 1; * use d:\ drive or o:\ drive;

if `DDrive' == 0 {;
	local prof "O:\USER_LIB\g1ebf00\prof\";
};
else { ;
	local prof "c:\research\hrs\prof\";
	local output "c:\research\hrs\prof\output\";
};
log using `prof'inshaz.log, replace ; 

use c:\research\hrs\merge\merge7;
sum age;
compress;
drop if male~=1;
sum age;
drop if (age<49|age>69);

tab wave;

keep if birthyr>1930 & birthyr<1936; * check out only old guys;
* keep if birthyr>1936 & birthyr<1942; * check out only young guys;
*keep if birthyr>1930 & birthyr<1942; * check out both groups;




* drop if realyear>100; * decide whether I want the post-2000 group;
* drop if realyear<99;

*********** preferences here *************;
*To do self-employment robustness check, uncomment the below line of code;
gen dropself=1;
*change the below line of code to gen meas= 0, 1, 2 or 3; 
gen meas=2; 

replace dropself=0 if meas~=2;
drop if (work==2 & dropself==1);
* what measurement error correction would you like to use?;
* meas=0 => measurement error coding and use first observed health insurance;
* meas=1 => raw data;
* meas=2 => no measurement error, use first observed health insurance;   
* meas=3 => measurement error coding, last period's health insurance;
* meas=4 => use lfprz (XX) no measurement error, use first observed health insurance;   ; 
* meas=5 => use lfprz (XX) no measurement error, use first observed health insurance;   ; 




*******here's where the program starts ***************;
replace linsnone=linsnonex if meas==1;
replace leprhi=leprhix if meas==1;
replace linstie=linstiex if meas==1;

replace linsnone=linsnonexx if (meas==2|meas==4|meas==5);
replace leprhi=leprhixx if (meas==2|meas==4|meas==5);
replace linstie=linstiexx if (meas==2|meas==4|meas==5);

replace linsnone=linsnonexxx if meas==3;
replace leprhi=leprhixxx if meas==3;
replace linstie=linstiexxx if meas==3;

drop if (linsnone==.|leprhi==.|linstie==.);

* check that nothing is screwed up with haz measure (looks ok);
drop haz;
sort HHID PN age1;
gen haz=.;
replace haz=1 if lfpr==1 & lfpr[_n-1]==1 & HHID==HHID[_n-1] & PN==PN[_n-1] & age1==age1[_n-1]+1;
replace haz=0 if lfpr==0 & lfpr[_n-1]==1 & HHID==HHID[_n-1] & PN==PN[_n-1] & age1==age1[_n-1]+1;
* replace haz=-1 if lfpr==1 & lfpr[_n-1]==0 & HHID==HHID[_n-1] & PN==PN[_n-1] & age1==age1[_n-1]+1; * haz=-1 if the individual re-enters;

gen temp=1-haz;
* gen temp=enter; *look at re-entry rates instead of exit rates;
replace haz=temp;
drop temp;


sort age;
by age: sum haz if linstie==1;
by age: sum haz if leprhi==1;
by age: sum haz if linsnone==1;


save c:\research\hrs\prof\merge7, replace;



program define gendum;
    version 3.1 ; 
    local i = 51 ;
    while `i' <=69 { ;
	gen linstie`i'=0;
	replace linstie`i'=linstie if age1==`i';
	gen linsnone`i'=0;
	replace linsnone`i'=linsnone if age1==`i';
	gen leprhi`i'=0;
	replace leprhi`i'=leprhi if age1==`i';
local i = `i'+1 } ;

end ;
gendum;

program define makea;
	version 3.1;
		local i = 50;
		while `i' <=70{;
		gen a`i'=0;
		replace a`i'=1 if age1==`i';
		local i=`i'+1 };
end;
makea;


************generate F-tests here, only for ages 59-67  **************;
reg haz leprhi62 linstie62 if age==62;  * R2 gives F-test for hypothesis of equality, stata gives p-val;
reg haz leprhi62 if age==62 & linsnone==0;  * R2 gives F-test for hypothesis of equality, stata gives p-val;
reg haz leprhi65 linstie65 if age==65;  * R2 gives F-test for hypothesis of equality, stata gives p-val;
reg haz leprhi65 if age==65 & linsnone==0; 

reg haz a60-a67 if age>58 & age<68;
reg haz linsnone59 leprhi59 linsnone60 linstie60 leprhi60 -linstie67 linsnone67 leprhi67 if age>58 & age<68;
* see p 130 pyndick & rubenfeld for the F-test  of the added parameters for the profiels being statistically different;

reg haz a60-a67 if age>58 & age<68 & linsnone==0; ;
reg haz leprhi59 linstie60 leprhi60 linstie61 leprhi61 linstie62 leprhi62 linstie63 leprhi63 linstie64 leprhi64 linstie65 leprhi65 linstie66 leprhi66 linstie67 leprhi67 if age>58 & age<68 & linsnone==0; 


***********************************************************************;




*sort age1;
*by age1: sum haz if linstie==1;


*reg lfpr linsnone51 leprhi51 linsnone52 linstie52 leprhi52 -linstie69 linsnone69 leprhi69  ;
reg haz linsnone51 leprhi51 linsnone52 linstie52 leprhi52 -linstie69 linsnone69 leprhi69  ;

gen rhaz=.;
gen thaz=.;
gen nhaz=.;




drop if (age1<53|age1>69);
sort age1;
drop if age1==age1[_n-1];


program define makehaz;
    version 3.1 ; 
    local i = 53 ;
    while `i' <=69 { ;

replace thaz=_b[_cons]+_b[linstie`i'] if (age1==`i');
replace nhaz=_b[_cons]+_b[linsnone`i'] if (age1==`i');
replace rhaz=_b[_cons]+_b[leprhi`i'] if (age1==`i');
sum thaz;
local i = `i'+1 } ;

sum age1 nhaz;
****************************************************;
replace nhaz=_b[_cons]+_b[linsnone51] if (age1==51);
replace rhaz=_b[_cons]+_b[leprhi51] if (age1==51);
****************************************************;
sum age1 nhaz;
end ;
makehaz;


sort age1;
by age1: sum thaz nhaz rhaz;



* keep tolfpr thaz tlfpr rhaz rlfpr nhaz nlfpr none ret tied age1;

sort age1;
by age1: summ thaz rhaz nhaz age1;
label var thaz "tied health insurance";
label var nhaz "no health insurance";
label var rhaz "retiree health insurance coverage";
label var age1 "age";


drop if age1<59|age1>68;

if (meas==2 & dropself==1)
{;
twoway connected thaz rhaz nhaz age1, legend() saving(inshazselfemp, replace)    
   ti("Robustness Check: ") subti("exclude the self-employed") 
   l1("exit rate") ytitle("")  mstyle(p1 p2 p3) msymbol( Oh Dh Th);

graph use inshazselfemp.gph;
graph export `output'inshazselfemp.eps, replace;
};

if meas==0
{;

twoway connected thaz rhaz nhaz age1, legend() saving(inshaz0, replace) 
   ti("Robustness Check:") subti("measurement error corrections and first observed health insurance")
   l1("exit rate") ytitle("") mstyle(p1 p2 p3) msymbol( Oh Dh Th);
graph use inshaz0.gph;
graph export `output'inshaz0.eps, replace;
};

if meas==1
{;
twoway connected thaz rhaz nhaz age1, legend() saving(inshaz1, replace)
   ti("Robustness Check:") subti("no measurement error corrections, last period's health insurance") 
   l1("exit rate") mstyle(p1 p2 p3) msymbol( Oh Dh Th);

graph use inshaz1.gph;
graph export `output'inshaz1.eps, replace;
};

if ( meas==2 & dropself==0)
{;
twoway connected thaz rhaz nhaz age1, legend() saving(inshaz2, replace)
   ti("Baseline Case:") subti("no measurement error corrections, use first observed health insurance") 
   l1("exit rate") ytitle("") mstyle(p1 p2 p3) msymbol( Oh Dh Th);
graph use inshaz2.gph;
graph export `output'inshaz2.eps, replace;
};

if meas==3
{;
twoway connected thaz rhaz nhaz age1, legend() saving(inshaz3, replace)
   ti("Robustness Check:") subti("measurement error corrections, last period's health insurance")
   l1("exit rate") mstyle(p1 p2 p3) msymbol( Oh Dh Th);
graph use inshaz3.gph;
graph export `output'inshaz3.eps, replace;
};

if meas==4
{;
twoway connected thaz rhaz nhaz age1, legend() saving(inshaz2, replace)
   ti("Robustness Check:") subti("measure participation on birthday") 
   l1("exit rate") ytitle("") mstyle(p1 p2 p3) msymbol( Oh Dh Th);
graph use inshaz2.gph;
graph export `output'inshaz2_on_birthday.eps, replace;
};

if meas==5
{;
twoway connected thaz rhaz nhaz age1, legend() saving(inshaz2, replace)
   ti("Robustness Check:") subti("measure participation on birthday plus 6 months") 
   l1("exit rate") ytitle("") mstyle(p1 p2 p3) msymbol( Oh Dh Th);
graph use inshaz2.gph;
graph export `output'inshaz2_on_birthday+half.eps, replace;
};


save `prof'inshaz, replace;
log close ;
clear;

