# delimit ;  
set more 1 ;  
drop _all;
capture log close;
set mem 500m;
log using c:\research\hrs\prof\merge11.log, replace ; 
* here I generate matrices that are fed into GAUSS ;
* I generate EXCEL tables which I convert to GAUSS datasets in DBMSCOPY;
program drop _all;



use c:\research\hrs\prof\merge10;


gen oner =1;
sort oner;
merge oner using C:\research\hrs\prof\prefweights.dta ;
sum _merge;
drop _merge;
gen pref_index=V3319*bV3319+V9063*bV9063+V5009*bV5009+V3319zero*bV3319zero+V9063miss*bV9063miss+V5009miss*bV5009miss+lfprw1*blfprw1;


drop if pref_index==.;
drop if asset51==.;

save c:\research\hrs\prof\merge11, replace;
drop healw* ltie* lnone* leprhi* lfpr;
drop age asset;

set matsize 500;
keep 
hourb* hourg*    
lfprb* lfprg*
asset* indnum birthyr pref_index lfprw1 ;


aorder;
order asset* hourbn* hourbr* hourbt* hourgn* hourgr* hourgt* 
lfprbn* lfprbr* lfprbt* lfprgn* lfprgr* lfprgt* birthyr pref_index lfprw1 indnum;

sort indnum;
save c:\research\hrs\prof\merge12a, replace;
sort indnum;
drop indnum;
summ;
outsheet using C:\research\hrs\prof\output\maindata, nonames replace;
drop _all;

use c:\research\hrs\prof\merge11;
program define asseter;
        version 3.1;
    	local i = 51 ;
    	while `i' <=69 { ; 
            gen wasset`i'=0;
		replace wasset`i'=1 if asset`i'~=0;
* people without hi;
		gen wlfprgn`i'=(1-healw`i')*lnone`i';
		gen wlfprbn`i'=healw`i'*lnone`i';
		gen whourbn`i'=healw`i'*lnone`i';
		replace whourbn`i'=0 if hourbn`i'==0;
		gen whourgn`i'= (1-healw`i')*lnone`i';
		replace whourgn`i'=0 if hourgn`i'==0;
* people with tied hi;
		gen wlfprgt`i'=(1-healw`i')*ltie`i';
		gen wlfprbt`i'=healw`i'*ltie`i';
		gen whourbt`i'=healw`i'*ltie`i';
		replace whourbt`i'=0 if hourbt`i'==0;
		gen whourgt`i'= (1-healw`i')*ltie`i';
		replace whourgt`i'=0 if hourgt`i'==0;		
* people with eprhi;
		gen wlfprgr`i'=(1-healw`i')*leprhi`i';
		gen wlfprbr`i'=healw`i'*leprhi`i';
		gen whourbr`i'=healw`i'*leprhi`i';
		replace whourbr`i'=0 if hourbr`i'==0;
		gen whourgr`i'= (1-healw`i')*leprhi`i';
		replace whourgr`i'=0 if hourgr`i'==0;
* find the total weight (should equal 1);
		gen lfprw`i'=(wlfprgn`i'*lfprgn`i')+(wlfprgt`i'*lfprgt`i')+(wlfprgr`i'*lfprgr`i');
		gen hourw`i'=whourgn`i'+whourgt`i'+whourgr`i';
* check the weights; 
tab lfprw`i'; * should equal zero or 1;
tab hourw`i'; * should equal zero or 1;
gen badw`i'=0;
replace badw`i'=1 if (wlfprgn`i'<0|wlfprgt`i'<0|wlfprgr`i'<0|whourgn`i'<0|whourgt`i'<0|whourgr`i'<0);
sum badw`i';
local i = `i'+1 } ;  

sum lfprw*;


keep wasset* wlfp* whou* indnum birthyr pref_index lfprw1;
end;
set trace off ;
asseter;

aorder;
order  wasset* whourbn* whourbr* whourbt* whourgn* whourgr* whourgt* 
wlfprbn* wlfprbr* wlfprbt* wlfprgn* wlfprgr* wlfprgt* birthyr pref_index lfprw1 indnum;

summ;
sort indnum;
save c:\research\hrs\prof\merge12b, replace;
drop indnum;
outsheet using C:\research\hrs\prof\output\wgtdata,nonames replace;
drop _all;

use c:\research\hrs\prof\merge12a,replace;
sort indnum;
merge indnum using c:\research\hrs\prof\merge12b;
drop _merge;

* this is to check that everything makes sense;
program define assetex;
        version 3.1;
    	local i = 51 ;
    	while `i' <=69 { ; 
            gen xasset`i'=wasset`i'*asset`i';
		replace wasset`i'=1 if asset`i'~=0;
* people without hi;
		gen xlfpgn`i'=wlfprgn`i'*lfprgn`i';
		gen xlfpbn`i'=wlfprbn`i'*lfprbn`i';
		gen xhoubn`i'=whourbn`i'*hourbn`i';
		gen xhougn`i'=whourgn`i'*hourgn`i';
* people with tied hi;
		gen xlfpgt`i'=wlfprgt`i'*lfprgt`i';
		gen xlfpbt`i'=wlfprbt`i'*lfprbt`i';
		gen xhoubt`i'=whourbt`i'*hourbt`i';
		gen xhougt`i'=whourgt`i'*hourgt`i';
				
* people with eprhi;
		gen xlfpgr`i'=wlfprgr`i'*lfprgr`i';
		gen xlfpbr`i'=wlfprbr`i'*lfprbr`i';
		gen xhoubr`i'=whourbr`i'*hourbr`i';
		gen xhougr`i'=whourgr`i'*hourgr`i';
local i = `i'+1 } ;  

end;
set trace off ;
assetex;

summ x*;
save c:\research\hrs\prof\merge12c, replace;
log close ;

