# delimit ;  set more 1 ;  set matsize 500;  
log using c:\research\hrs\prof\profols1.log, replace ; 
 
drop _all; 
program drop _all;
set trace on;
use c:\research\hrs\merge\merge7;
compress;
drop if male~=1;

* what measurement error correction would you like to use?;
* meas=0 => measurement error coding and use first observed health insurance;
* meas=1 => raw data;
* meas=2 => no measurement error, use first observed health insurance;   
* meas=3 => measurement error coding, last period's health insurance;
gen meas=2; 

replace linsnone=linsnonex if meas==1;
replace leprhi=leprhix if meas==1;
replace linstie=linstiex if meas==1;

replace linsnone=linsnonexx if meas==2;
replace leprhi=leprhixx if meas==2;
replace linstie=linstiexx if meas==2;

replace linsnone=linsnonexxx if meas==3;
replace leprhi=leprhixxx if meas==3;
replace linstie=linstiexxx if meas==3;

tab leprhi;
tab linstie;
tab linsnone; 

drop if age1<51|age1>69;

drop if (leprhi==0 & linstie==0 & linsnone==0);
* gen ins=leprhi+linstie+linsnone;
drop if ins~=1;
drop if leprhi==.|linstie==.|linsnone==.;
tab leprhi;
tab linstie;
tab linsnone;
drop if healb==.|healg==.;
tab leprhi;
tab linstie;
tab linsnone;



*-----------------------------------------------------------------------;
*generate age*health*health insurance;
program define makeagn;
	version 3.1;
		local i = 50;
		while `i' <=70{;
		gen agn`i'=0;
		replace agn`i'=(healg*linsnone) if age1==`i' ;
		local i=`i'+1 };
end;
makeagn;
program define makeabn;
	version 3.1;
		local i = 50;
		while `i' <=70{;
		gen abn`i'=0;
		replace abn`i'=(healb*linsnone) if age1==`i' ;
		local i=`i'+1 };
end;
makeabn;

program define makeagt;
	version 3.1;
		local i = 50;
		while `i' <=70{;
		gen agt`i'=0;
		replace agt`i'=(linstie*healg) if age1==`i' ;
		local i=`i'+1 };
end;
makeagt;
program define makeabt;
	version 3.1;
		local i = 50;
		while `i' <=70{;
		gen abt`i'=0;
		replace abt`i'=(linstie*healb) if age1==`i' ;
		local i=`i'+1 };
end;
makeabt;

program define makeagr;
	version 3.1;
		local i = 50;
		while `i' <=70{;
		gen agr`i'=0;
		replace agr`i'=(leprhi*healg) if age1==`i';
		local i=`i'+1 };
end;
makeagr;
program define makeabr;
	version 3.1;
		local i = 50;
		while `i' <=70{;
		gen abr`i'=0;
		replace abr`i'=(leprhi*healb) if age1==`i';
		local i=`i'+1 };
end;
makeabr;


save c:\research\hrs\prof\merge7, replace;



keep indnum age1;
sort indnum age1;
save c:\research\hrs\prof\merge8,replace;
sort age1;
drop if age1==age1[_n-1];
keep age1;
sort age1;
save c:\research\hrs\prof\profile, replace;
drop _all; 

*use c:\research\hrs\prof\profile;
set matsize 500;

*----------------------------------------------------------;
* make dummies here                                        ;

*----------------------------------------------------------;
* no health insurance--------------------------------------;
program define gnavg;
    version 3.1 ; 
    local i = 51 ;
    while `i' <=69 { ;

	replace abn`i'=0;	
	replace agn`i'=0;
	replace abt`i'=0;	
	replace agt`i'=0;
	replace abr`i'=0;	
	replace agr`i'=0;
	replace agn`i'=1 if age1==`i';
local i = `i'+1 } ;
end ;

program define bnavg;
    version 3.1 ; 
    local i = 51 ;
    while `i' <=69 { ;
	replace abn`i'=0;	
	replace agn`i'=0;
	replace abt`i'=0;	
	replace agt`i'=0;
	replace abr`i'=0;	
	replace agr`i'=0;
	replace abn`i'=1 if age1==`i';	
local i = `i'+1 } ;

end ;

* tied health insurance------------------------------------;
program define gtavg;
    version 3.1 ; 
    local i = 51 ;
    while `i' <=69 { ;
	replace abn`i'=0;	
	replace agn`i'=0;
	replace abt`i'=0;	
	replace agt`i'=0;
	replace abr`i'=0;	
	replace agr`i'=0;
	replace agt`i'=1 if age1==`i';
local i = `i'+1 } ;
end ;

program define btavg;
    version 3.1 ; 
    local i = 51 ;
    while `i' <=69 { ;
	replace abn`i'=0;	
	replace agn`i'=0;
	replace abt`i'=0;	
	replace agt`i'=0;
	replace abr`i'=0;	
	replace agr`i'=0;
	replace abt`i'=1 if age1==`i';	
local i = `i'+1 } ;

end ;

* retiree health insurance------------------------------------;
program define gravg;
    version 3.1 ; 
    local i = 51 ;
    while `i' <=69 { ;
	replace abn`i'=0;	
	replace agn`i'=0;
	replace abt`i'=0;	
	replace agt`i'=0;
	replace abr`i'=0;	
	replace agr`i'=0;
	replace agr`i'=1 if age1==`i';
local i = `i'+1 } ;
end ;

program define bravg;
    version 3.1 ; 
    local i = 51 ;
    while `i' <=69 { ;
	replace abn`i'=0;	
	replace agn`i'=0;
	replace abt`i'=0;	
	replace agt`i'=0;
	replace abr`i'=0;	
	replace agr`i'=0;
	replace abr`i'=1 if age1==`i';	
local i = `i'+1 } ;

end ;

* first rename profile variable y, make both ;
*	*** LEVELS FOR WAGES LFPR, AND HOURS***;
* generate unsmoothed profiles;
* here is where I get the residuals;
program define mprofw ;
    version 3.1 ;
	use c:\research\hrs\prof\merge7;
	set matsize 500;
	gen y=`1';
drop if y==.;
summ y;
sort indnum;
 reg y  
agn52-agn69
abn51-abn69 
agt51-agt69
abt51-abt69 
agr51-agr69
abr51-abr69;
predict ypred;
gen res=y-ypred;

sum lfpr y ypred age leprhi ag* ab* if indnum==55711040 & age==69;


gnavg;
predict levelrn0; 
predict selevn0, stdp;
gen dlevrn0=res+levelrn0;

bnavg;
predict levelrn1; 
predict selevn1, stdp;
gen dlevrn1=res+levelrn1;

gtavg;
predict levelrt0; 
predict selevt0, stdp;
gen dlevrt0=res+levelrt0;

btavg;
predict levelrt1; 
predict selevt1, stdp;
gen dlevrt1=res+levelrt1;

gravg;
predict levelrr0; 
predict selevr0, stdp;
gen dlevrr0=res+levelrr0;

sum lfpr dlevrr0 y ypred age leprhi ag* ab* if indnum==55711040 & age==69;

bravg;
predict levelrr1; 
predict selevr1, stdp;
gen dlevrr1=res+levelrr1;

gen selevhn0=levelrn0+(2*selevn0);
gen selevln0=levelrn0-(2*selevn0);
gen selevhn1=levelrn1+(2*selevn1);
gen selevln1=levelrn1-(2*selevn1);


gen selevht0=levelrt0+(2*selevt0);
gen selevlt0=levelrt0-(2*selevt0);
gen selevht1=levelrt1+(2*selevt1);
gen selevlt1=levelrt1-(2*selevt1);


gen selevhr0=levelrr0+(2*selevr0);
gen selevlr0=levelrr0-(2*selevr0);
gen selevhr1=levelrr1+(2*selevr1);
gen selevlr1=levelrr1-(2*selevr1);


tab dlevrn0 if dlevrn0<3 & age1==55;
tab dlevrn1 if dlevrn1<3 & age1==55;
tab dlevrt0 if dlevrt0<3 & age1==55;
tab dlevrt1 if dlevrt1<3 & age1==55;
tab dlevrr0 if dlevrr0<3 & age1==55;
tab dlevrr1 if dlevrr1<3 & age1==55;

summ linsnone linstie leprhi healw dlevrn0 dlevrn1 dlevrt0 dlevrt1 dlevrr0 dlevrr1;

* BLOCK THIS OUT FOR COMING DAYS WHEN THERE IS MEASUREMENT ERROR;
*replace dlevrn0=0 if healw~=0|linsnone~=1;
*replace dlevrn1=0 if healw~=1|linsnone~=1;
*replace dlevrt0=0 if healw~=0|linstie~=1;
*replace dlevrt1=0 if healw~=1|linstie~=1;
*replace dlevrr0=0 if healw~=0|leprhi~=1;
*replace dlevrr1=0 if healw~=1|leprhi~=1;

* tab dlevrn0 if dlevrn0<3;
* tab dlevrn1 if dlevrn1<3;
* tab dlevrt0 if dlevrt0<3;
* tab dlevrt1 if dlevrt1<3;
* tab dlevrr0 if dlevrr0<3;
* tab dlevrr1 if dlevrr1<3;

tab ins;

gen insz=leprhi+linsnone+linstie;
tab insz;


keep realyear birthyr levelr* dlevr*  indnum V3319 lfprw1 V3319zero V5009 V5009miss V9063 V9063miss  age1 heal* linstie linsnone leprhi y wave selev* ins;
sort indnum age1;
merge indnum age1 using c:\research\hrs\prof\merge8;
drop _merge;

*sum age1;
*exit;



gen inszz= leprhi+linsnone+linstie;
tab inszz;
drop inszz;
sort indnum age1;
save c:\research\hrs\prof\merge8, replace;

drop if levelrn0==.|levelrn1==.|levelrt0==.|levelrt1==.;
sort age1;
drop if age1==age1[_n-1];

keep realyear birthyr levelr* age1 healg selev*;

sort age1;
merge age1 using c:\research\hrs\prof\profile;
drop _merge;
sort age1;

end;

*****************************************************************************;
* get profile variables for hours and lfpr  ;
set trace off; 
 
* hours ;
mprofw lhours ;

* this should get at that it is lhours--antilog for hours; 
replace levelrn0=exp(levelrn0) if levelrn0 >= 3; 
replace selevhn0=exp(selevhn0) if levelrn0 >= 3; 
replace selevln0=exp(selevln0) if levelrn0 >= 3; 
replace levelrn1=exp(levelrn1) if levelrn1 >= 3; 
replace selevhn1=exp(selevhn1) if levelrn1 >= 3; 
replace selevln1=exp(selevln1) if levelrn1 >= 3; 

replace levelrt0=exp(levelrt0) if levelrt0 >= 3; 
replace selevht0=exp(selevht0) if levelrt0 >= 3; 
replace selevlt0=exp(selevlt0) if levelrt0 >= 3; 
replace levelrt1=exp(levelrt1) if levelrt1 >= 3; 
replace selevht1=exp(selevht1) if levelrt1 >= 3; 
replace selevlt1=exp(selevlt1) if levelrt1 >= 3; 

replace levelrr0=exp(levelrr0) if levelrr0 >= 3; 
replace selevhr0=exp(selevhr0) if levelrr0 >= 3; 
replace selevlr0=exp(selevlr0) if levelrr0 >= 3; 
replace levelrr1=exp(levelrr1) if levelrr1 >= 3; 
replace selevhr1=exp(selevhr1) if levelrr1 >= 3; 
replace selevlr1=exp(selevlr1) if levelrr1 >= 3;

summ;
rename levelrn0 hoursn0; 
rename selevhn0 hourshn0;
rename selevln0 hoursln0;
rename levelrn1 hoursn1;
rename selevhn1 hourshn1;
rename selevln1 hoursln1;

rename levelrt0 hourst0; 
rename selevht0 hoursht0;
rename selevlt0 hourslt0;
rename levelrt1 hourst1;
rename selevht1 hoursht1;
rename selevlt1 hourslt1;

rename levelrr0 hoursr0; 
rename selevhr0 hourshr0;
rename selevlr0 hourslr0;
rename levelrr1 hoursr1;
rename selevhr1 hourshr1;
rename selevlr1 hourslr1;

save c:\research\hrs\prof\profile, replace;
drop _all;

use c:\research\hrs\prof\merge8;

rename dlevrn0 dhourn0; 
rename dlevrn1 dhourn1;
rename dlevrt0 dhourt0; 
rename dlevrt1 dhourt1;
rename dlevrr0 dhourr0; 
rename dlevrr1 dhourr1;

rename y lhours;

gen inszy= leprhi+linsnone+linstie;
tab inszy;
drop inszy;

save c:\research\hrs\prof\merge8, replace;

drop _all;

* lfpr ;
mprofw lfpr ;
summ;
rename levelrn0 lfprn0; 
rename selevhn0 lfprhn0;
rename selevln0 lfprln0;
rename levelrn1 lfprn1;
rename selevhn1 lfprhn1;
rename selevln1 lfprln1;

rename levelrt0 lfprt0; 
rename selevht0 lfprht0;
rename selevlt0 lfprlt0;
rename levelrt1 lfprt1;
rename selevht1 lfprht1;
rename selevlt1 lfprlt1;

rename levelrr0 lfprr0; 
rename selevhr0 lfprhr0;
rename selevlr0 lfprlr0;
rename levelrr1 lfprr1;
rename selevhr1 lfprhr1;
rename selevlr1 lfprlr1;

save c:\research\hrs\prof\profile, replace;
* merge with asset profiles;

merge age1 using c:\research\hrs\prof\asset1;

keep age1 realyear birthyr
lfpr* 
hour* 
wpred plus2se minus2se;
order age1 
lfprn0 lfprln0 lfprhn0
lfprn1 lfprln1 lfprhn1 
hoursn0 hoursln0 hourshn0
hoursn1 hoursln1 hourshn1 
lfprt0 lfprlt0 lfprht0
lfprt1 lfprlt1 lfprht1 
hourst0 hourslt0 hoursht0
hourst1 hourslt1 hoursht1
lfprr0 lfprlr0 lfprhr0
lfprr1 lfprlr1 lfprhr1 
hoursr0 hourslr0 hourshr0
hoursr1 hourslr1 hourshr1
wpred plus2se minus2se;

sort age1;
save c:\research\hrs\prof\profile, replace ;
outsheet using c:\research\hrs\prof\profile, nonames replace;
drop _all;

use c:\research\hrs\prof\merge8;
rename dlevrn0 dlfprn0;
rename dlevrn1 dlfprn1;
rename dlevrt0 dlfprt0;
rename dlevrt1 dlfprt1;
rename dlevrr0 dlfprr0;
rename dlevrr1 dlfprr1;
drop level* se*;
rename y lfpr;

gen inszy= leprhi+linsnone+linstie;
tab inszy;
drop inszy;

sort indnum age1;
merge indnum age1 using c:\research\hrs\prof\asset;
drop _merge;

gen inszy= leprhi+linsnone+linstie;
tab inszy;
drop inszy;

save c:\research\hrs\prof\merge8, replace;
summ;

drop _all ;
log close ;

