# delimit ;  
drop _all; 
set more 1 ;  
set matsize 1000;   ; 
set mem 500m; 
* profwage.do 8/2009   Program to produce wage profiles.;
       

program drop _all;
capture log close;
log using c:\research\hrs\prof\profwage.log,replace;

use c:\research\hrs\merge\merge7a;



***********************************************;
*this will give data from more cohorts         ;
*doesn't change anything;
*need to generate a single health variable     ;
/*
drop _all;
use c:\research\hrs\merge\merge5;
drop if male~=1;
gen long indnum=HHID*1000+PN;
gen lhours=ln(hours);
gen healw=0;
replace healw=1 if heal==4|heal==5|dead==1;
gen age1=age;
gen ageg1=age1;
gen linstiexx=0;
gen leprhixx=0;
*/

*********************************************;

sum *wage* realyear;


*keep if age1>51 & age1<72;

* drop if wave>100;
drop if age>200; * fix this -- it is one person;
*drop if realyear<94;
*drop if realyear>104;
*drop if hrscoh~=1;
*drop if wave<6;




* generate wage variable;
* decide whether to use wage or wage net of part-time wage penalty;
sort indnum realyear;
gen lwage=ln(wage);
gen l2000=ln(2000);
gen lwagej=lwage-(.415*lhours)+(.415*l2000);
*replace lwage=lwagej;

replace heal=healw;

sort indnum wave;
gen dlwage=lwage-lwage[_n-1] if indnum==indnum[_n-1] & wave==wave[_n-1]+1;
gen dheal=heal-heal[_n-1] if indnum==indnum[_n-1] & wave==wave[_n-1]+1;
gen ldheal=dheal[_n-1] if indnum==indnum[_n-1] & wave==wave[_n-1]+1;

*drop if dheal~=0;
*drop if ldheal~=0;

drop if lhours==0;
drop if lhours==.;
tab realyear;

drop ageg* ;
gen age2=age1*age1;
gen age3=age2*age1;
gen age4=age3*age1;


sort wave;

by wave: sum dl* dh* wage;


gen healtrue=heal;
gen healage1=heal*age1;
gen healage2=heal*age2;
gen healage3=heal*age3;
gen healage4=heal*age4;



* polynomial in realyear;
gen ryear2=realyear*realyear;
gen ryear3=ryear2*realyear ;

*	***  WAGES ***;

* generate unsmoothed fixed effects profiles, order:;
* wages not affected by hours, health=good, wages not affected by hours, health=bad,  ;
* wages affected by hours, health=good, wages affected by hours, health=bad,  ;

tab realyear;

set matsize 800;
sort indnum;


****************************preliminary regressions;
reg lwage heal ;
reg lwage heal age1 healage1;
xtreg lwage heal , fe i(indnum);
xtreg lwage heal age1 healage1, fe i(indnum);
reg dlwage;
xtreg lwage age1 , fe i(indnum);

* disaggregate by health insurance type ;
gen linstieage1=linstiexx*age1;
gen leprhiage1=leprhixx*age1;
xtreg lwage age1 linstieage1 leprhiage1, fe i(indnum);


****************************wages not affected by hours, health=good****************;
xtreg lwage  
age1 age2 age3 age4 heal healage1 healage2 healage3 healage4, fe i(indnum);
replace heal=0;
replace healage1=heal*age1;
replace healage2=heal*age2;
replace healage3=heal*age3;
replace healage4=heal*age4;
predict lwagepg;

gen wagepg=exp(lwagepg);




****************************wages not affected by hours, health=bad****************;
replace heal=healtrue;
replace healage1=heal*age1;
replace healage2=heal*age2;
replace healage3=heal*age3;
replace healage4=heal*age4;

xtreg lwage  
age1 age2 age3 age4 heal healage1 healage2 healage3 healage4, fe i(indnum);

replace heal=1;
replace healage1=heal*age1;
replace healage2=heal*age2;
replace healage3=heal*age3;
replace healage4=heal*age4;
predict lwagepb;

gen wagepb=exp(lwagepb);



****************************wages affected by hours, health=good****************;
replace lwage=lwagej;


replace heal=healtrue;
replace healage1=heal*age1;
replace healage2=heal*age2;
replace healage3=heal*age3;
replace healage4=heal*age4;

xtreg lwage  
age1 age2 age3 age4 heal healage1 healage2 healage3 healage4, fe i(indnum);

replace heal=0;
replace healage1=heal*age1;
replace healage2=heal*age2;
replace healage3=heal*age3;
replace healage4=heal*age4;
predict lwagepgt;

gen wagepgt=exp(lwagepgt);


****************************wages affected by hours, health=bad****************;
replace heal=healtrue;
replace healage1=heal*age1;
replace healage2=heal*age2;
replace healage3=heal*age3;
replace healage4=heal*age4;

xtreg lwage  
age1 age2 age3 age4 heal healage1 healage2 healage3 healage4, fe i(indnum);

replace heal=1;
replace healage1=heal*age1;
replace healage2=heal*age2;
replace healage3=heal*age3;
replace healage4=heal*age4;
predict lwagepbt;

gen wagepbt=exp(lwagepbt);


drop if age>85|age<50;
sort age;
drop if age==age[_n-1];


two conn wagepg wagepb age1, ylabel(0(5)20) msymbol(T S D O) lpattern(solid longdash shortdash longdash_dot) ti("Wages, by Health Status, Wages NOT Affected by Hours", size(medsmall)) l1(1998 dollars) ytitle("") saving(wageexog, replace);
graph use wageexog.gph;
graph display, ysize(6) xsize(8.25);
graph export c:\research\hrs\prof\wageexog.emf, replace;

two conn wagepgt wagepbt age1, ylabel(0(5)20) msymbol(T S D O) lpattern(solid longdash shortdash longdash_dot) ti("Wages, by Health Status, Wages Affected by Hours, if Working 2000 Hours", size(medsmall)) l1(1998 dollars) ytitle("") saving(wagetied, replace);
graph use wagetied.gph;
graph display, ysize(6) xsize(8.25);
graph export c:\research\hrs\prof\wagetied.emf, replace;


keep  age1 wagepg wagepb wagepgt wagepbt;
order age1 wagepg wagepb wagepgt wagepbt;

sum;

outsheet using c:\research\hrs\prof\wageprof_HRS,nonames replace;

save c:\research\hrs\prof\wageprof_HRS, replace;

*drop _all;
log close;





